﻿import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.*;
import java.io.File;
import javax.swing.*;


public class CSSForm extends ChildForm   implements ActionListener {
	
    JMenuBar menuBar1 = new JMenuBar();

  
  public CSSForm() {
    this("");
  }
  
  public CSSForm(String sFilename) {
    super(sFilename);
    setGUI();
    setVisible(true);  
    // installLnF();
  }

  
  // wird aufgerufen wird Clientfenster, abgeleitet
  private void setGUI() {
    setMenues();
  }
  private void insertMenue(JMenu parent, String sTitle, String sHashValue) {
    MyJMenuItem menu = new MyJMenuItem(sTitle, sHashValue);
    parent.add(menu);
    menu.addActionListener(this);
  }
  
  public void actionPerformed(ActionEvent e) {
    MyJMenuItem menu = (MyJMenuItem) e.getSource();
    String sValue = menu.HashValue;
    StartCommand(sValue, menu.getText());
  }  
  
  private void StartCommand(String sValue, String Caption) {
    if (sValue.equals("InsertCSS_Body")) {
          Middleware.InsertCSS_Body(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_xx")) {
          Middleware.InsertCSS_xx(getEditor());
          return;
    }
    if (sValue.equals("InsertCSS_H2")) {
          Middleware.InsertCSS_H2(getEditor());
          return;
    }
    

    if (sValue.equals("InsertCSS_PositionAbsolute")) {
          Middleware.InsertCSS_PositionAbsolute(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_PositionRelativ")) {
          Middleware.InsertCSS_PositionRelativ(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Multidefinition")) {
          Middleware.InsertCSS_Multidefinition(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_SelektorenBehind")) {
          Middleware.InsertCSS_SelektorenBehind(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_SelektorenTopDown")) {
          Middleware.InsertCSS_SelektorenTopDown(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_SelektorenTogether")) {
          Middleware.InsertCSS_SelektorenTogether(getEditor());
          return;
    }
    

    if (sValue.equals("InsertCSS_background_image")) {
          Middleware.InsertCSS_background_image(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Body_backgroundrepeat")) {
          Middleware.InsertCSS_Body_backgroundrepeat(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Bodybackgroundattachment")) {
          Middleware.InsertCSS_Bodybackgroundattachment(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Body_backgroundposition")) {
          Middleware.InsertCSS_Body_backgroundposition(getEditor());
          return;
    }
              
    

    if (sValue.equals("InsertCSS_FontColor")) {
          Middleware.InsertCSS_FontColor(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_ColorConstant")) {
          Middleware.InsertCSS_ColorConstant(getEditor());
          return;
    }
                
    if (sValue.equals("InsertCSS_BackgroundColor")) {
          Middleware.InsertCSS_BackgroundColor(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_FontSize_12em")) {
          Middleware.InsertCSS_FontSize_12em(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_FontColor")) {
          Middleware.InsertCSS_FontColor(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Fonttyp_Verdana")) {
          Middleware.InsertCSS_Fonttyp_Verdana(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Fonttyp_CourierNew")) {
          Middleware.InsertCSS_Fonttyp_CourierNew(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Fonttyp_Monospace")) {
          Middleware.InsertCSS_Fonttyp_Monospace(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_SmallestFont")) {
          Middleware.InsertCSS_SmallestFont(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_SmallerFont")) {
          Middleware.InsertCSS_SmallerFont(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_BiggerFont")) {
          Middleware.InsertCSS_BiggerFont(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_BigFont")) {
          Middleware.InsertCSS_BigFont(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_FontSize_15Em")) {
          Middleware.InsertCSS_FontSize_15Em(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_Bigger_Percentage")) {
          Middleware.InsertCSS_Bigger_Percentage(getEditor());
          return;
    }
                                                    
    if (sValue.equals("InsertCSS_FontWeight")) {
          Middleware.InsertCSS_FontWeight(getEditor());
          return;
    }
                                                    
    if (sValue.equals("InsertCSS_WordSpacing")) {
          Middleware.InsertCSS_WordSpacing(getEditor());
          return;
    }
                                                            
    if (sValue.equals("InsertCSS_LetterSpacing")) {
          Middleware.InsertCSS_LetterSpacing(getEditor());
          return;
    }
                                                            
    if (sValue.equals("InsertCSS_Text_Indent")) {
          Middleware.InsertCSS_Text_Indent(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_Textdecoration_None")) {
          Middleware.InsertCSS_Textdecoration_None(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Textdecoration_Underline")) {
          Middleware.InsertCSS_Textdecoration_Underline(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Textdecoration_Overline")) {
          Middleware.InsertCSS_Textdecoration_Overline(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Textdecoration_linethrough")) {
          Middleware.InsertCSS_Textdecoration_linethrough(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Textdecoration_blink")) {
          Middleware.InsertCSS_Textdecoration_blink(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_Textdecoration_Italic")) {
          Middleware.InsertCSS_Textdecoration_Italic(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_TextTransform_none")) {
          Middleware.InsertCSS_TextTransform_none(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_TextTransform_uppercase")) {
          Middleware.InsertCSS_TextTransform_uppercase(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_TextTransform_lowercase")) {
          Middleware.InsertCSS_TextTransform_lowercase(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_TextTransform_capitalize")) {
          Middleware.InsertCSS_TextTransform_capitalize(getEditor());
          return;
    }
    
    
    if (sValue.equals("InsertCSS_Textalign_left")) {
          Middleware.InsertCSS_Textalign_left(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Textalign_center")) {
          Middleware.InsertCSS_Textalign_center(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Textalign_right")) {
          Middleware.InsertCSS_Textalign_right(getEditor());
          return;
    }
                        
    if (sValue.equals("InsertCSS_Textalign_justify")) {
          Middleware.InsertCSS_Textalign_justify(getEditor());
          return;
    }
    

    if (sValue.equals("InsertCSS_Valign_baseline")) {
          Middleware.InsertCSS_Valign_baseline(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Valign_Sub")) {
          Middleware.InsertCSS_Valign_Sub(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Valign_Super")) {
          Middleware.InsertCSS_Valign_Super(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Valign_texttop")) {
          Middleware.InsertCSS_Valign_texttop(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Valign_textbottom")) {
          Middleware.InsertCSS_Valign_textbottom(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_Valign_middle")) {
          Middleware.InsertCSS_Valign_middle(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_Valign_top")) {
          Middleware.InsertCSS_Valign_top(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Valign_bottom")) {
          Middleware.InsertCSS_Valign_bottom(getEditor());
          return;
    }
                
    if (sValue.equals("InsertCSS_Valign_percentage")) {
          Middleware.InsertCSS_Valign_percentage(getEditor());
          return;
    }
    

    if (sValue.equals("InsertCSS_UL_listeNone")) {
          Middleware.InsertCSS_UL_listeNone(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_UL_Listecircle")) {
          Middleware.InsertCSS_UL_Listecircle(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_UL_Listesquare")) {
          Middleware.InsertCSS_UL_Listesquare(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_UL_Listedisc")) {
          Middleware.InsertCSS_UL_Listedisc(getEditor());
          return;
    }
                    
                    
    if (sValue.equals("InsertCSS_OL_ListeNone")) {
          Middleware.InsertCSS_OL_ListeNone(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_OL_Listedecimal")) {
          Middleware.InsertCSS_OL_Listedecimal(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_OL_Listedecimalleadingzero")) {
          Middleware.InsertCSS_OL_Listedecimalleadingzero(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_OL_Listelowerroman")) {
          Middleware.InsertCSS_OL_Listelowerroman(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_OL_Listeupperroman")) {
          Middleware.InsertCSS_OL_Listeupperroman(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_OL_Listelowergreek")) {
          Middleware.InsertCSS_OL_Listelowergreek(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_OL_Listeuppergreek")) {
          Middleware.InsertCSS_OL_Listeuppergreek(getEditor());
          return;
    }
                                                    
    if (sValue.equals("InsertCSS_OL_Listelowerlatin")) {
          Middleware.InsertCSS_OL_Listelowerlatin(getEditor());
          return;
    }
                                                    
    if (sValue.equals("InsertCSS_OL_ListeUpperlatin")) {
          Middleware.InsertCSS_OL_ListeUpperlatin(getEditor());
          return;
    }
                                                            
    if (sValue.equals("InsertCSS_ListStylePosition_inside")) {
          Middleware.InsertCSS_ListStylePosition_inside(getEditor());
          return;
    }
                                                            
    if (sValue.equals("InsertCSS_ListStylePosition_outside")) {
          Middleware.InsertCSS_ListStylePosition_outside(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_BlockTH")) {
          Middleware.InsertCSS_BlockTH(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_BlockTD")) {
          Middleware.InsertCSS_BlockTD(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_TableBorderTDTHTable")) {
          Middleware.InsertCSS_TableBorderTDTHTable(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_FieldsetLegend")) {
          Middleware.InsertCSS_FieldsetLegend(getEditor());
          return;
    }
    if (sValue.equals("InsertCSS_inputRequired")) {
        Middleware.InsertCSS_inputRequired(getEditor());
        return;
  }
    if (sValue.equals("InsertCSS_inputInvalid")) {
        Middleware.InsertCSS_inputInvalid(getEditor());
        return;
  }

    
    if (sValue.equals("InsertCSS_GridLayout")) {
        Middleware.InsertCSS_GridLayout(getEditor());
        return;
  }
    
    
    if (sValue.equals("InsertCSS_Bordercolor")) {
          Middleware.InsertCSS_Bordercolor(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_BorderWidth")) {
          Middleware.InsertCSS_BorderWidth(getEditor());
          return;
    }
    
    
    if (sValue.equals("InsertCSS_Bordercolor")) {
          Middleware.InsertCSS_Bordercolor(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_BorderStyleNone")) {
          Middleware.InsertCSS_BorderStyleNone(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_BorderStyleHidden")) {
          Middleware.InsertCSS_BorderStyleHidden(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_BorderStyleDotted")) {
          Middleware.InsertCSS_BorderStyleDotted(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_BorderStyleDashed")) {
          Middleware.InsertCSS_BorderStyleDashed(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_BorderStyleSolid")) {
          Middleware.InsertCSS_BorderStyleSolid(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_BorderStyleDouble")) {
          Middleware.InsertCSS_BorderStyleDouble(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_BorderStyleGroove")) {
          Middleware.InsertCSS_BorderStyleGroove(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_BorderStyleRidge")) {
          Middleware.InsertCSS_BorderStyleRidge(getEditor());
          return;
    }
                                    
    if (sValue.equals("InsertCSS_BorderStyleInset")) {
          Middleware.InsertCSS_BorderStyleInset(getEditor());
          return;
    }
                                            
    if (sValue.equals("InsertCSS_BorderStyleOutset")) {
          Middleware.InsertCSS_BorderStyleOutset(getEditor());
          return;
    }

    if (sValue.equals("InsertCSS_PaddingOneForfour")) {
          Middleware.InsertCSS_PaddingOneForfour(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_PaddingTwoForTwo")) {
          Middleware.InsertCSS_PaddingTwoForTwo(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_PaddingFourForFour")) {
          Middleware.InsertCSS_PaddingFourForFour(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_PaddingTop")) {
          Middleware.InsertCSS_PaddingTop(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_PaddingLeft")) {
          Middleware.InsertCSS_PaddingLeft(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_PaddingBottom")) {
          Middleware.InsertCSS_PaddingBottom(getEditor());
          return;
    }
                                                                                    
    if (sValue.equals("InsertCSS_Paddingright")) {
          Middleware.InsertCSS_Paddingright(getEditor());
          return;
    }
    
    if (sValue.equals("InsertCSS_MarginOneForFour")) {
          Middleware.InsertCSS_MarginOneForFour(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_MarginTwoForTwo")) {
          Middleware.InsertCSS_MarginTwoForTwo(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_MarginFourForFour")) {
          Middleware.InsertCSS_MarginFourForFour(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_MarginTop")) {
          Middleware.InsertCSS_MarginTop(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_MarginLeft")) {
          Middleware.InsertCSS_MarginLeft(getEditor());
          return;
    }
                            
    if (sValue.equals("InsertCSS_MarginBottom")) {
          Middleware.InsertCSS_MarginBottom(getEditor());
          return;
    }
                                                                                    
    if (sValue.equals("InsertCSS_Marginright")) {
          Middleware.InsertCSS_MarginRight(getEditor());
          return;
    }

    if (sValue.equals("InsertCSS_Links_NoneVisited")) {
          Middleware.InsertCSS_Links_NoneVisited(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Links_Visited")) {
          Middleware.InsertCSS_Links_Visited(getEditor());
          return;
    }
            
    if (sValue.equals("InsertCSS_Links_Activate")) {
          Middleware.InsertCSS_Links_Activate(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Links_ThreeLinks")) {
          Middleware.InsertCSS_Links_ThreeLinks(getEditor());
          return;
    }
                    
    if (sValue.equals("InsertCSS_Links_ThreeLinksTogether")) {
          Middleware.InsertCSS_Links_ThreeLinksTogether(getEditor());
          return;
    }
    
    Basis.ErrorBox("Menü "+Caption+" konnte nicht als Aktion gefunden werden\n"
            +"Bitte EMail an Herrn Wilhelm ","Fehler" );
    
    
  }  // StartCommand
/*
    if (sValue.equals("mmmmm")) {
          Middleware.mmmmmm(getEditor());
          return;
    }
    
    */
  
  private void setMenues() {
    this.setJMenuBar(menuBar1);
    
    JMenu MainCSS = new JMenu("Basis CSS");
    menuBar1.add(MainCSS);
    
    insertMenue(MainCSS,"Basic CSS","InsertCSS_Body");
    insertMenue(MainCSS,"empty CSS-Selector","InsertCSS_xx");
    
    insertMenue(MainCSS,"h2","InsertCSS_H2");
    
    insertMenue(MainCSS,"Position absolute","InsertCSS_PositionAbsolute");
    insertMenue(MainCSS,"Position relativ","InsertCSS_PositionRelativ");
    insertMenue(MainCSS,"Multidefinition","InsertCSS_Multidefinition");
    insertMenue(MainCSS,"Item sequentiell definition body > h2","InsertCSS_SelektorenBehind");
    insertMenue(MainCSS,"Item after Definition, h1+h2","InsertCSS_SelektorenTopDown");
    insertMenue(MainCSS,"Item nebeneinander","InsertCSS_SelektorenTogether");
    
    
    JMenu MainImages = new JMenu("Picture");
    menuBar1.add(MainImages);
    insertMenue(MainImages,"Body: background-image","InsertCSS_background_image");
    insertMenue(MainImages,"Body: background-repeat","InsertCSS_Body_backgroundrepeat");
    insertMenue(MainImages,"Body: background-attachment","InsertCSS_Bodybackgroundattachment");
    insertMenue(MainImages,"Body: background-position","InsertCSS_Body_backgroundposition");
    
    
    JMenu MainColors = new JMenu("Colors");
    menuBar1.add(MainColors);
    insertMenue(MainColors,"&Farbe (Hex)","InsertCSS_FontColor");
    insertMenue(MainColors,"&Farbe Textkonstante","InsertCSS_ColorConstant");
    insertMenue(MainColors,"Hintergrundfarbe","InsertCSS_BackgroundColor");
    
    
    JMenu MainFonts = new JMenu("Fonts");
    menuBar1.add(MainFonts);
    insertMenue(MainFonts,"Font Size=1.2em","InsertCSS_FontSize_12em");
    insertMenue(MainFonts,"Font color","InsertCSS_FontColor");
    
    JMenu MnFont = new JMenu("Fontname");    
    MainFonts.add(MnFont);
    insertMenue(MnFont,"Verdana, Arial, Helvetica, Swiss","InsertCSS_Fonttyp_Verdana");
    insertMenue(MnFont,"Courier New","InsertCSS_Fonttyp_CourierNew");
    insertMenue(MnFont,"Monospace","InsertCSS_Fonttyp_Monospace");
    
            
    JMenu MnFontsize = new JMenu("rel. Fontsize");
    MainFonts.add(MnFontsize);
    insertMenue(MnFontsize,"ganz kleine Schrift","InsertCSS_SmallestFont");
    insertMenue(MnFontsize,"Kleiner","InsertCSS_SmallerFont");
    insertMenue(MnFontsize,"Größer","InsertCSS_BiggerFont");
    insertMenue(MnFontsize,"ganz große Schrift","InsertCSS_BigFont");
    insertMenue(MnFontsize,"größere Schrift em","InsertCSS_FontSize_15Em");
    insertMenue(MnFontsize,"größere Schrift %","InsertCSS_Bigger_Percentage");
        
    
    insertMenue(MainFonts,"Schriftstärke","InsertCSS_FontWeight");
    insertMenue(MainFonts,"Word-Spacing","InsertCSS_WordSpacing");
    insertMenue(MainFonts,"Letter-Spacing","InsertCSS_LetterSpacing");
    insertMenue(MainFonts,"Texteinrücken (text-indent)","InsertCSS_Text_Indent");

    JMenu MnTextDecoration = new JMenu("text-decoration");
    MainFonts.add(MnTextDecoration);
    insertMenue(MnTextDecoration,"none","InsertCSS_Textdecoration_None");
    insertMenue(MnTextDecoration,"underline","InsertCSS_Textdecoration_Underline");
    insertMenue(MnTextDecoration,"overline","InsertCSS_Textdecoration_Overline");
    insertMenue(MnTextDecoration,"durchgestrichen","InsertCSS_Textdecoration_linethrough");
    insertMenue(MnTextDecoration,"blinkend","InsertCSS_Textdecoration_blink");
    insertMenue(MnTextDecoration,"Italic / Kursiv","InsertCSS_Textdecoration_Italic");
    
    
    JMenu MnTextTransform = new JMenu("text-transform");
    MainFonts.add(MnTextTransform);
    insertMenue(MnTextTransform,"none","InsertCSS_TextTransform_none");
    insertMenue(MnTextTransform,"uppercase","InsertCSS_TextTransform_uppercase");
    insertMenue(MnTextTransform,"lowercase","InsertCSS_TextTransform_lowercase");
    insertMenue(MnTextTransform,"capitalize","InsertCSS_TextTransform_capitalize");

    

    
    JMenu  MnCSS_HAlign = new JMenu("Horizontal Alignment");
    MainFonts.add(MnCSS_HAlign);
    insertMenue(MnCSS_HAlign,"Links ausgerichtet","InsertCSS_Textalign_left");
    insertMenue(MnCSS_HAlign,"Zentriert ausgerichtet","InsertCSS_Textalign_center");
    insertMenue(MnCSS_HAlign,"Rechts ausgerichtet","InsertCSS_Textalign_right");
    insertMenue(MnCSS_HAlign,"Blocksatz","InsertCSS_Textalign_justify");
    
    
    JMenu  MnCSS_VAlign = new JMenu("Vertical Alignment");
    MainFonts.add(MnCSS_VAlign);
    insertMenue(MnCSS_VAlign,"baseline","InsertCSS_Valign_baseline");
    insertMenue(MnCSS_VAlign,"sub","InsertCSS_Valign_Sub");
    insertMenue(MnCSS_VAlign,"sup","InsertCSS_Valign_Super");
    insertMenue(MnCSS_VAlign,"text-top","InsertCSS_Valign_texttop");
    insertMenue(MnCSS_VAlign,"text-bottom","InsertCSS_Valign_textbottom");
    insertMenue(MnCSS_VAlign,"middle","InsertCSS_Valign_middle");
    insertMenue(MnCSS_VAlign,"top","InsertCSS_Valign_top");
    insertMenue(MnCSS_VAlign,"bottom","InsertCSS_Valign_bottom");
    insertMenue(MnCSS_VAlign,"percentage","InsertCSS_Valign_percentage");
    
    
    
    JMenu MainList = new JMenu("Lists");
    menuBar1.add(MainList);

    JMenu  MnCSS_Listen_UL = new JMenu("ul");
    MainList.add(MnCSS_Listen_UL);
    insertMenue(MnCSS_Listen_UL,"none","InsertCSS_UL_listeNone");
    insertMenue(MnCSS_Listen_UL,"circle","InsertCSS_UL_Listecircle");
    insertMenue(MnCSS_Listen_UL,"square","InsertCSS_UL_Listesquare");
    insertMenue(MnCSS_Listen_UL,"disc","InsertCSS_UL_Listedisc");

    
    JMenu  MnCSS_Listen_OL = new JMenu("ol");
    MainList.add(MnCSS_Listen_OL);
    insertMenue(MnCSS_Listen_OL,"none","InsertCSS_OL_ListeNone");
    insertMenue(MnCSS_Listen_OL,"decimal","InsertCSS_OL_Listedecimal");
    insertMenue(MnCSS_Listen_OL,"decimal-leading-zero","InsertCSS_OL_Listedecimalleadingzero");
    insertMenue(MnCSS_Listen_OL,"lower-roman","InsertCSS_OL_Listelowerroman");
    insertMenue(MnCSS_Listen_OL,"upper-roman","InsertCSS_OL_Listeupperroman");
    insertMenue(MnCSS_Listen_OL,"lower-greek","InsertCSS_OL_Listelowergreek");
    insertMenue(MnCSS_Listen_OL,"upper-greek","InsertCSS_OL_Listeuppergreek");
    insertMenue(MnCSS_Listen_OL,"lower-latin","InsertCSS_OL_Listelowerlatin");
    insertMenue(MnCSS_Listen_OL,"upper-latin","InsertCSS_OL_ListeUpperlatin");


    JMenu  Mnliststyleposition = new JMenu("list-style-position");
    MainList.add(Mnliststyleposition);
    insertMenue(Mnliststyleposition,"inside","InsertCSS_ListStylePosition_inside");
    insertMenue(Mnliststyleposition,"outside","InsertCSS_ListStylePosition_outside");
    
    
    JMenu MainTables = new JMenu("Tables");
    menuBar1.add(MainTables);
    
    insertMenue(MainTables,"th","InsertCSS_BlockTH");
    insertMenue(MainTables,"td","InsertCSS_BlockTD");
    insertMenue(MainTables,"Tabellen mit Rand","InsertCSS_TableBorderTDTHTable");
    
    
    JMenu MainForms = new JMenu("Forms");
    menuBar1.add(MainForms);
    insertMenue(MainForms,"Fieldset Legend / Label","InsertCSS_FieldsetLegend");
    insertMenue(MainForms,"input:required","InsertCSS_inputRequired");
    insertMenue(MainForms,"input:invalid","InsertCSS_inputInvalid");

    JMenu MainLayouts = new JMenu("Layouts");
    menuBar1.add(MainLayouts);
    insertMenue(MainLayouts,"GridLayout (label/inputtext)","InsertCSS_GridLayout");
    
    
    JMenu MainBorders = new JMenu("Borders");
    menuBar1.add(MainBorders);
    
    insertMenue(MainBorders,"Border-Farbe","InsertCSS_Bordercolor");      
    insertMenue(MainBorders,"Border-Width","InsertCSS_BorderWidth");    
    
    JMenu  MnInsertCSS_BorderStyles = new JMenu("Border-Styles");
    MainBorders.add(MnInsertCSS_BorderStyles);
    insertMenue(MnInsertCSS_BorderStyles,"none","InsertCSS_BorderStyleNone");
    insertMenue(MnInsertCSS_BorderStyles,"hidden","InsertCSS_BorderStyleHidden");
    insertMenue(MnInsertCSS_BorderStyles,"dotted","InsertCSS_BorderStyleDotted");
    insertMenue(MnInsertCSS_BorderStyles,"dashed","InsertCSS_BorderStyleDashed");
    insertMenue(MnInsertCSS_BorderStyles,"solid","InsertCSS_BorderStyleSolid");
    insertMenue(MnInsertCSS_BorderStyles,"double","InsertCSS_BorderStyleDouble");
    insertMenue(MnInsertCSS_BorderStyles,"groove","InsertCSS_BorderStyleGroove");
    insertMenue(MnInsertCSS_BorderStyles,"ridge","InsertCSS_BorderStyleRidge");
    insertMenue(MnInsertCSS_BorderStyles,"inset","InsertCSS_BorderStyleInset");
    insertMenue(MnInsertCSS_BorderStyles,"outset","InsertCSS_BorderStyleOutset");
    
        
      // ---------
    JMenu  MnInsertCSS_Padding = new JMenu("Padding");
    MainBorders.add(MnInsertCSS_Padding);
      
    insertMenue(MnInsertCSS_Padding,"Ein Wert für alle vier Werte","InsertCSS_PaddingOneForfour");
    insertMenue(MnInsertCSS_Padding,"Zwei Werte: top/bottom  und left/right","InsertCSS_PaddingTwoForTwo");
    insertMenue(MnInsertCSS_Padding,"Vier Werte","InsertCSS_PaddingFourForFour");
    MnInsertCSS_Padding.addSeparator();
    insertMenue(MnInsertCSS_Padding,"Padding-top","InsertCSS_PaddingTop");
    insertMenue(MnInsertCSS_Padding,"Padding-left","InsertCSS_PaddingLeft");
    insertMenue(MnInsertCSS_Padding,"Padding-bottom","InsertCSS_PaddingBottom");
    insertMenue(MnInsertCSS_Padding,"Padding-right","InsertCSS_Paddingright");
    
      
      
    JMenu MnInsertCSS_Margin = new JMenu("Margin");
    MainBorders.add(MnInsertCSS_Margin);
    insertMenue(MnInsertCSS_Margin,"Ein Wert für alle vier Werte","InsertCSS_MarginOneForFour");
    insertMenue(MnInsertCSS_Margin,"Zwei Werte: top/bottom  und left/right","InsertCSS_MarginTwoForTwo");
    insertMenue(MnInsertCSS_Margin,"Vier Werte","InsertCSS_MarginFourForFour");
    MnInsertCSS_Margin.addSeparator();
    insertMenue(MnInsertCSS_Margin,"Margin-top","InsertCSS_MarginTop");
    insertMenue(MnInsertCSS_Margin,"Margin-left","InsertCSS_MarginLeft");
    insertMenue(MnInsertCSS_Margin,"Margin-bottom","InsertCSS_MarginBottom");
    insertMenue(MnInsertCSS_Margin,"Margin-right","InsertCSS_MarginRight");
    

    
    JMenu MainLinks = new JMenu("Links");
    menuBar1.add(MainLinks);
    insertMenue(MainLinks,"None Visited","InsertCSS_Links_NoneVisited");
    insertMenue(MainLinks,"Visited","InsertCSS_Links_Visited");
    insertMenue(MainLinks,"Activate","InsertCSS_Links_Activate");
    insertMenue(MainLinks,"Alle drei Links (untereinander)","InsertCSS_Links_ThreeLinks");
    insertMenue(MainLinks,"Alle drei Links (zusammen)","InsertCSS_Links_ThreeLinksTogether");
    
  
    
  }  
  
  public void setFontSize(int fontsize) {
	  Basis.setMenueFont( menuBar1,false, fontsize);
	  super._lineeditor.setFont( new Font("Courier New", Font.PLAIN,fontsize)  );
	  super._editor.setFont( new Font("Courier New", Font.PLAIN,fontsize)  );
  }
  
  
}
