﻿import java.awt.Color;
import java.awt.Frame;
import javax.swing.*;
import javax.swing.text.Caret;


public class Middleware {
        private static Middleware instance = new Middleware();
        
        private static String sAddZeile = "";        
        
        private static String lineseparator = Basis.getlineSeparator();

        private Middleware()
        {
        }

        public static Middleware getInstance()
        {
            return instance;
        }
        
        private static void InsertZeile(JTextArea editor, String sText)     {
          int i;
          // suche naechste Zeile
          String sFullText = editor.getText();                    
          if (sFullText.equals("")) {
            editor.setText(sText);
          }
          else {
            i = sFullText.indexOf(lineseparator);  // Basis.getlineSeparator()
            if (i>=0) {          
              int currentCaretPosition = editor.getCaretPosition();  // aktuelle CursorPosition
              // bestimme aktuelle Zeile (row)
              String sEditor = editor.getText().substring(currentCaretPosition);
              i = sEditor.indexOf(lineseparator);
              System.out.println("currentCaretPosition: "+currentCaretPosition);
              editor.insert(sText, currentCaretPosition+i+1); 
            }
            else {
              editor.setText(sFullText+lineseparator+sText);
            }
          }
          /*
            Line currentLine = editor.Lines.Current;
            int position = currentLine.StartPosition;
            editor.InsertText(position, sText + );
            editor.Modified = true;*/
        }

        public static void InsertText(JTextArea editor, String sText)     {   
          Caret car = editor.getCaret();
          int currentCaretPosition = editor.getCaretPosition();
           editor.insert(sText, currentCaretPosition); 
           // editor.Modified = true;
        }

        private static void AddZeile(String sText)
        {
            sAddZeile += sText + lineseparator;
            System.out.println(lineseparator);
        }
        
        
        public static void InsertHTML_Basic_XHTML_strict11(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            AddZeile("<!DOCTYPE html");
            AddZeile("     PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
            AddZeile("    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
            AddZeile("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            AddZeile("  <head>");
            AddZeile("    <title> Beispiel 1 </title>");
            AddZeile("      <meta name=\"author\" content=\"Administrator\"/>");
            AddZeile("      <meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            AddZeile("  </head>");
            AddZeile("  <body>");  //  xmlns="http://www.w3.org/1999/xhtml"
            AddZeile("    <h1>");
            AddZeile("      Überschrift");
            AddZeile("    </h1>");
            AddZeile("  </body>");
            AddZeile("</html>");
            editor.setText(sAddZeile);
        }

        public static void InsertHTML_Basic_XHTML(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<?xml version=\"1.0\" ?>");
            AddZeile("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"");
            AddZeile("        \"http://www.w3.org/TR/html4/strict.dtd\">");
            AddZeile("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            AddZeile("  <head>");
            AddZeile("    <title> Beispiel 1 </title>");
            AddZeile("      <meta name=\"author\" content=\"Administrator\"/>");
            AddZeile("      <meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            AddZeile("  </head>");
            AddZeile("  <body>");
            AddZeile("    <h1>");
            AddZeile("      Überschrift");
            AddZeile("    </h1>");
            AddZeile("  </body>");
            AddZeile("</html>");
           // InsertZeile(editor, sAddZeile);
            editor.setText(sAddZeile);
        }
        public static void InsertHTML_HTML4(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"");
            AddZeile("          \"http://www.w3.org/TR/html4/loose.dtd\">");
            AddZeile("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            AddZeile("  <head>");
            AddZeile("    <title> Beispiel 1 </title>");
            AddZeile("      <meta name=\"author\" content=\"Administrator\"/>");
            AddZeile("      <meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            AddZeile("  </head>");
            AddZeile("  <body>");
            AddZeile("    <h1>");
            AddZeile("      Überschrift");
            AddZeile("    </h1>");
            AddZeile("  </body>");
            AddZeile("</html>");
            //  InsertZeile(editor, sAddZeile);
            editor.setText(sAddZeile);
        }


        public static void InsertHTML_Basic_Pur(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<html>");
            AddZeile("  <head>");
            AddZeile("    <title> Beispiel 1 </title>");
            AddZeile("  </head>");
            AddZeile("  <body>");
            AddZeile("    <p>");
            AddZeile("      1. Zeile");
            AddZeile("    </p>");
            AddZeile("  </body>");
            AddZeile("</html>");
            // InsertZeile(editor, sAddZeile);
            editor.setText(sAddZeile);
        }

        
        public static void InsertHTML_Header(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <h1>");            
            AddZeile("    Text H1");            
            AddZeile("  </h1>");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Paragraph(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <p>");            
            AddZeile("    Text p");            
            AddZeile("  </p>");            
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertHTML_Header3(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <h3>");            
            AddZeile("    Text H3");            
            AddZeile("  </h3>");            
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertHTML_UL(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <ul>");            
            AddZeile("    <li>Text1</li>");            
            AddZeile("    <li>Text2</li>");
            AddZeile("  </ul>");            
            InsertZeile(editor, sAddZeile);
        }
                        
        public static void InsertHTML_OL(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <ol>");            
            AddZeile("    <li>Text1</li>");            
            AddZeile("    <li>Text2</li>");
            AddZeile("  </ol>");            
            InsertZeile(editor, sAddZeile);
        }
                      
        private static void createTable(JTextArea editor, int AnzRow, int AnzCol, 
                  boolean bHeaderInFirstRow, boolean bHeaderInFirstCol,
                  boolean bHead, boolean bFoot, boolean bBody, boolean bCellSpace_Padding, boolean bMitColGroup,
                  int iCellFrame) {
            int nr, c, r;
            String sTable;
            sAddZeile = "";
            AddZeile("<!-- Tabelle -->");
            sTable="  <table ";
            if (bCellSpace_Padding) sTable+=" cellspacing=\"20\" cellpadding=\"20%\" ";
            switch (iCellFrame) {
                case 1: sTable+="above ";
                        break;
                case 2: sTable+="below ";
                        break;
                case 3: sTable+="vsided ";
                        break;
                case 4: sTable+="lhs ";
                        break;
                case 5: sTable+="rhs ";
                        break;
                case 6: sTable+="box ";
                        break;
                case 7: sTable+="border ";
                        break;
            }
            AddZeile(sTable+">");
            if (bMitColGroup) {
               AddZeile("  <colgroup>");
               for (c=0; c<AnzCol; c++) {
                 AddZeile("    <col width=\"80\"/>");
               }
               AddZeile("  </colgroup>");
            }
                        
            if (bHead) {
                AddZeile("   <thead>");
                AddZeile("    <tr>");
                for (c = 0; c < AnzCol; c++)
                {
                    AddZeile("     <th>");
                    AddZeile("     </th>");
                }
                AddZeile("    </tr>");
                AddZeile("   </thead>");
            }

            nr=0;
            
            if (bBody) AddZeile("   <tbody>");
            for (r=0; r<AnzRow; r++) {                
                AddZeile("     <tr>");
                for (c=0; c<AnzCol; c++) {                  
                    if ( (c==1) && bHeaderInFirstRow) {
                        if ((r==1) && bHeaderInFirstRow ) 
                            AddZeile("      <th> <br /> </th>");
                        else 
                            AddZeile("      <th> "+nr+"-zelle</th>");
                    }
                    else {
                        if ((r==1) && bHeaderInFirstCol) 
                            AddZeile("      <th> <br /> </th>");
                        else 
                            AddZeile("      <td> "+nr+"-zelle</td>");
                    }
                }  // for (c=0; c<AnzCol; c++) {                  
                AddZeile("     </tr>");
            }  // for (r=0; r<AnzRow; r++) {                
            if (bBody) AddZeile("     </tbody>");

         
              if (bFoot) {
                  AddZeile("   <tfoot>");
                AddZeile("    <tr>");
                for (c = 0; c < AnzCol; c++)
                {
                    AddZeile("     <td>");
                    AddZeile("     </td>");
                }
                AddZeile("    </tr>");
                AddZeile("   </tfoot>");
              }
              AddZeile("  </table>");
              InsertZeile(editor, sAddZeile);
        }  // createTable
  
              
        public static void InsertHTML_Table(JTextArea editor)
        {
          FInsertHTMLTable form = new FInsertHTMLTable(null);
          if (form.bResult) {
            createTable(editor, form.AnzRow, form.AnzCol, form.HeaderInFirstRow, form.HeaderInFirstCol,
                    form.Head, form.Body, form.Foot, form.CellSpacing,  form.Colgroup,  form.CellFrame);
          }
        }
                        

        public static void InsertHTML_TR(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <tr>");            
            AddZeile("    <td>Text1</td>");            
            AddZeile("    <td>Text2</td>");
            AddZeile("  </tr>");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_HR(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <hr noshade size=\"1\" />");            
            InsertZeile(editor, sAddZeile);
        }
                        
                        
              
        public static void InsertHTML_EMailLink(JTextArea editor)
        {
            sAddZeile = "  <a href=\"mailto:\"> Adresse </a>";
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Link(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <a href=\"bsp.html\">   text  </a>");            
            InsertZeile(editor, sAddZeile);
        }
                        
            
        public static void InsertHTML_Anchor(JTextArea editor)
        {
            sAddZeile = "<a name=\"\"> </a>";
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Comment(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  <!--  Kommentar -->");            
            InsertZeile(editor, sAddZeile);
        }
                        
        
        public static void InsertCSS_ColorConstant(JTextArea editor) // JFrame parent
        {          
            FSelectColorConstant colorDlg = new FSelectColorConstant(null);            
            if ( colorDlg.bResult )
            {                
                InsertText(editor, colorDlg.sColor);
            }         
        }
        
        public static void InsertCSS_FontColor(JTextArea editor)
        {
          Color color = JColorChooser.showDialog(null, "Auswahl einer Farbe", Color.blue);
          if (color != null) {
            String sRed = Basis.getHex(color.getRed());
            String sBlue = Basis.getHex(color.getBlue());
            String sGreen = Basis.getHex(color.getGreen());
            InsertText(editor, "color:#" + sRed+sGreen+sBlue+";");            
          }
        }

        
        public static void InsertHTML_InsertImage(JTextArea editor, String sImagefile, boolean bWithCoord)
        {
            sAddZeile = "";
            if (bWithCoord) 
            {
                AddZeile("  <img src=\"" + Basis.getFileNameExt(sImagefile) + "\" alt=\"Beschreibender Text\" border=\"0\" usemap=\"#shapeareaname\" />");
                AddZeile("  <map name=\"shapeareaname\">");
                AddZeile("  ");
                AddZeile("  </map>");
            }
            else {
                AddZeile("  <img src=\"" + sImagefile + " alt=\"Beschreibender Text\" border=\"0\" />");
            }
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertHTML_Font_Bold(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<strong>  </strong>");            
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Font_Italic(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<i>  </i>");            
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Font_Underline(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<u>  </u>");            
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Font_LineThrough(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<s>  </s>");            
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Font_Sup(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<sup>  </sup>");            
            InsertText(editor, sAddZeile);
        }
                        
              
        public static void InsertHTML_Font_Sub(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<sub>  </sub>");            
            InsertText(editor, sAddZeile);
        }


        public static void InsertHTML_Font_Char_Space(JTextArea editor)
        {            
            InsertText(editor, "&#x0020;");
        }
                        
        public static void InsertHTML_Font_Char_Tab(JTextArea editor)
        {
            InsertText(editor, "&#x0009;");
        }
                        
              
        public static void InsertHTML_Font_Char_CR(JTextArea editor)
        {
            InsertText(editor, "&#x000D;");
        }
                        
              
        public static void InsertHTML_Font_Char_LF(JTextArea editor)
        {
            InsertText(editor, "&#x000A;");
        }
                        
              
        public static void InsertHTML_Font_Char_Blank(JTextArea editor)
        {
            InsertText(editor, "&#160;");  // festes Leerzeichen
        }
                        
              
        public static void InsertHTML_Font_Char_Dash(JTextArea editor)
        {
            InsertText(editor, "&#173;");
        }
                        
              
        public static void InsertHTML_Font_Char_Copyright(JTextArea editor)
        {
            InsertText(editor, "&#169;");
        }
                        
              
        public static void InsertHTML_Font_Char_Copyright_R(JTextArea editor)
        {
            InsertText(editor, "&#174;");
        }
                        
              
        public static void InsertHTML_Font_Char_Trademark(JTextArea editor)
        {
            InsertText(editor, "&#x8482;");
        }
                        
              
        public static void InsertHTML_Font_Char_LT(JTextArea editor)
        {
            InsertText(editor, "&#60;");  // <
        }
                        
              
        public static void InsertHTML_Font_Char_GT(JTextArea editor)
        {
            InsertText(editor, "&#62;");
        }
                        
              
        public static void InsertHTML_Font_Char_GTGT(JTextArea editor)
        {
            InsertText(editor, "&#187;");
        }

        public static void InsertHTML_Font_Char_LTLT(JTextArea editor)
        {
            InsertText(editor, "&#171;");
        }
        
        public static void InsertHTML_CSSReferenzExtern(JTextArea editor)
        {
            InsertText(editor, "&#171;");
            sAddZeile = "";
            AddZeile("  <!--  Muss in den Header-Abschnitt -->");            
            AddZeile("<link rel=\"stylesheet\" type=\"text/css\"  ");
            AddZeile("  href=\"style_bsp.css\" title=\"style1\"/>  ");            
            AddZeile("  ");            
            InsertZeile(editor, sAddZeile);
        }

    
              
        public static void InsertHTML_CSSReferenzLocal(JTextArea editor)
        {
            InsertText(editor, "&#171;");
            sAddZeile = "";
            AddZeile("  <!--  Muss in den Header-Abschnitt -->  ");
            AddZeile("  <style type=\"text/css\"  id=\"internalStyle\" >  ");            
            AddZeile("    body {  ");            
            AddZeile("      font-size: 1em;");            
            AddZeile("      color: rgb(255,100,100);  ");            
            AddZeile("      font-weight:300;  ");            
            AddZeile("    }  ");            
            AddZeile("  </style>  ");            
            AddZeile("  ");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Body(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("body {");
            AddZeile("  font-size: 1.2em;");
            AddZeile("  color: rgb(100,100,100);");
            AddZeile("  font-family: Arial, Helvetica, Verdana, sans-serif;");
            AddZeile("  font-weight: 400;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_xx(JTextArea editor)
        {
            sAddZeile = "";
              AddZeile("xx {");
              AddZeile("  font-family : Arial, Helvetica, Verdana, sans-serif;");
              AddZeile("  font-size: 1.4em;");
              AddZeile("  color: #0000FF;");
              AddZeile("  font-weight : normal;");
              AddZeile("}");
              InsertZeile(editor, sAddZeile);
        }
                           
        public static void InsertCSS_H2(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("h2{");
            AddZeile("  font-size: 1.2em;");
            AddZeile("  color: #0000FF;");
            AddZeile("  font-weight : ligther;");
            AddZeile("  background-color: yellow;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        // nur HTML
        public static void InsertCSS_OL(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("ol{");
            AddZeile("  list-style-type:upper-alpha;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertCSS_UL(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("ol{");
            AddZeile("  list-style-type:square;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertCSS_TH(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("th{");
            AddZeile("  font-family : Tahoma, Geneva, Arial, Helvetica, sans-serif;");
            AddZeile("  font-size: 1.5em;");
            AddZeile("  color1: #0000FF;");
            AddZeile("  font-weight : normal;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertCSS_TD(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("td{");
            AddZeile("  font-family : Tahoma, Geneva, Arial, Helvetica, sans-serif;");
            AddZeile("  font-size: 1.2em;");
            AddZeile("  color1: #FF00FF;");
            AddZeile("  font-weight : normal;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertHTML_Scrolling(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<div style=\"overflow: auto; width: 100px; height: 100px; \">");
            AddZeile("    <!-- Inhalt ->");
            AddZeile("</div>");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_background_image(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  background-image=url(\"bild.jpg\");");            
            InsertZeile(editor, sAddZeile);
        }



        public static void InsertCSS_Body_backgroundrepeat(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  background-repeat:no-repeat;  /* repeat-x  repeat-y repeat */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Bodybackgroundattachment(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  background-attachment:scroll;  /* scroll  fixed=bleibt beim scrollen fixed */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Body_backgroundposition(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  background-position:left;  /* left center right top bottom,   w% x% y% z%, 0.3em */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BackgroundColor(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  background-color: gray;");            
            InsertZeile(editor, sAddZeile);
        }
        
        
        public static void InsertCSS_FontSize_12em(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("    font-size: 1.2em;");            
            InsertZeile(editor, sAddZeile);
        }



        public static void InsertCSS_Fonttyp_Verdana(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-family: VERDANA,ARIAL,HELVETICA;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Fonttyp_CourierNew(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-family: COURIER NEW;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Fonttyp_Monospace(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-family: MONOSPACE;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_SmallestFont(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: xx-small;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_SmallerFont(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: -1;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BiggerFont(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: +1;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BigFont(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: xx-large;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_FontSize_15Em(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: 1.5em;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Bigger_Percentage(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-size: 150%;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_FontWeight(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-weight: 400;  /* 100 bis 900 */");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertCSS_WordSpacing(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  word-spacing:2pt;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_LetterSpacing(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  letter-spacing:3pt;");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertCSS_Textdecoration_None(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-decoration: none;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Textdecoration_Underline(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-decoration: underline;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textdecoration_Overline(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-decoration: overline;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textdecoration_linethrough(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("   text-decoration: line-through;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textdecoration_blink(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("   text-decoration:blink");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textdecoration_Italic(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  font-style:italic;");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertCSS_TextTransform_none(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-transform: none;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_TextTransform_uppercase(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-transform: uppercase;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_TextTransform_lowercase(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-transform: lowercase;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_TextTransform_capitalize(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-transform: capitalize;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Text_Indent(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-indent: 1.0in;");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertCSS_UL_listeNone(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: none;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_UL_Listecircle(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: circle;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_UL_Listesquare(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: square;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_UL_Listedisc(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: disc;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_ListeNone(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: none;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listedecimal(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: decimal;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listedecimalleadingzero(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: decimal-leading-zero;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listelowerroman(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: lower-roman;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listeupperroman(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: upper-roman;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listelowergreek(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: lower-greek;");            
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertCSS_OL_Listeuppergreek(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: upper-greek;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_Listelowerlatin(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: lower-latin;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_OL_ListeUpperlatin(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-type: upper-latin;");            
            InsertZeile(editor, sAddZeile);
        }

        
        
        public static void InsertCSS_ListStylePosition_inside(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-position: inside;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_ListStylePosition_outside(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  list-style-position: outside;");            
            InsertZeile(editor, sAddZeile);
        }

        
        public static void InsertCSS_BlockTH(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("th {");
            AddZeile("  font-family : Arial, Helvetica, Verdana, sans-serif;");
            AddZeile("  font-size: 1.5em;");
            AddZeile("  color1: #0000FF;");
            AddZeile("  font-weight : normal;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_BlockTD(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("td {");
            AddZeile("  font-family : Arial, Helvetica, Verdana, sans-serif;");
            AddZeile("  font-size: 1.1em;");
            AddZeile("  color1: #FF00FF;");
            AddZeile("  font-weight : normal;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_TableBorderTDTHTable(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("/* Aussenrand */");
            AddZeile("table {");
            AddZeile("  border: 1px solid; ");
            AddZeile("  border-collapse:collapse; /* verhindert doppelte Ränder */ ");
            AddZeile("}");

            AddZeile("");
            AddZeile("/* einfacher Rand in der Tabelle */");
            AddZeile("td, th {");
            AddZeile("  border: 1px solid; ");
            AddZeile("  border-color: black;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Bordercolor(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  border-color: red;");            
            InsertZeile(editor, sAddZeile);
        }        
        
        public static void InsertCSS_BorderStyleNone(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style: none;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleHidden(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style: hidden;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleDotted(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style: dotted;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleDashed(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:dashed;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleSolid(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:solid;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleDouble(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style: double;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleGroove(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:groove;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleRidge(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:ridge;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleInset(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:inset;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderStyleOutset(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-style:outset;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_BorderWidth(JTextArea  editor)
        {
            sAddZeile = "";
            AddZeile("  border-width:5px;");            
            InsertZeile(editor, sAddZeile);
        }
        
        
        
        public static void InsertCSS_PaddingOneForfour(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_PaddingTwoForTwo(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding: 10px 10px;  /* T/B  und L/R */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_PaddingFourForFour(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding: 10px 10px 10px 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_PaddingTop(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding-top: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_PaddingLeft(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding-left: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_PaddingBottom(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding-bottom: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Paddingright(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  padding-right: 10px;;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginOneForFour(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginTwoForTwo(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin: 10px 10px;  /* oder 10px  auto;  */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginFourForFour(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin: 10px 10px 10px 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginTop(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin-top: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginLeft(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin-left: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginBottom(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin-bottom: 10px;");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_MarginRight(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  margin-right: 10px;");            
            InsertZeile(editor, sAddZeile);
        }
                        
            
        public static void InsertCSS_Links_NoneVisited(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("a:link{");
            AddZeile("  color: #0000FF;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertCSS_Links_Visited(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("a:visited{");
            AddZeile("  color: #00FF00;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertCSS_Links_Activate(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("a:active{");
            AddZeile("  color: #FF0000;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertCSS_Links_ThreeLinks(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("a:link{");            
            AddZeile("    color: #0000FF;");            
            AddZeile("}");            
            AddZeile("");            
            AddZeile("a:visited{");            
            AddZeile("color: #00FF00;");            
            AddZeile("}");            
            AddZeile("");            
            AddZeile("a:active{");            
            AddZeile("  color: #FF0000;");            
            AddZeile("}");            
            AddZeile("");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertCSS_Links_ThreeLinksTogether(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("a:link, a:visited, a:active{");
            AddZeile("  color: #FF0000;");
            AddZeile("   /*text-decoration:none;*/");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_Textalign_left(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-align: left;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textalign_center(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-align:center;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textalign_right(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-align:right;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Textalign_justify(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  text-align:justify; /* Blocksatz */");            
            InsertZeile(editor, sAddZeile);
        }

        
        public static void InsertCSS_Valign_baseline(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align: baseline;");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertCSS_Valign_Sub(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:sub;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_Super(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:super;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_texttop(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:text-top;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_textbottom(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:text-bottom;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_middle(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:middle;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_top(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:top;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_bottom(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align:bottom;");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_Valign_percentage(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  vertical-align: 20%;  /*  -20%  oder +20% */");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_FieldsetLegend(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("fieldset {");
            AddZeile("  border: 2px solid #C5D8E1;");
            AddZeile("  border-radius: 10px;");
            AddZeile("  background: white;");
            AddZeile("  margin: 0;");
            AddZeile("  width:350px;");
            AddZeile("}");
            AddZeile("");
            AddZeile("legend { ");
            AddZeile(" color:red;");
            AddZeile("} ");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_inputRequired(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("input:invalid {");
            AddZeile("\tborder: solid 2px red;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertCSS_inputInvalid(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("input:required {");
            AddZeile("\tborder: solid 2px black;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        
        
        public static void InsertCSS_GridLayout(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("#wrapperdialog {");
            AddZeile("\t/*  1fr 14fr  ist das verhältnis zwischen den Spalten */");
            AddZeile("\tdisplay: grid;");
            AddZeile("\tgrid-template-columns: auto 1fr;");
            AddZeile("\tgrid-template-rows: auto auto auto;");
            AddZeile("\tgrid-column-gap: 10px;");
            AddZeile("\tgrid-row-gap: 10px;");
            AddZeile("\tbackground-color:red;");
            AddZeile("}");
            AddZeile("");
            AddZeile(".fbox1 {");
            AddZeile("");
            AddZeile("}");
            AddZeile("");
            AddZeile(".fbox2 {");
            AddZeile("\tmargin-right:5px;");
            AddZeile("}");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }
        
                
        
        public static void InsertForm_Formrange(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<form>");            
            AddZeile("");            
            AddZeile("</form>");            
            InsertZeile(editor, sAddZeile);
        }
                        
        public static void InsertForm_FormWithAction(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<form method=\"get\" action=\"test.php\" >");            
            AddZeile("");            
            AddZeile("</form>");            
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertGridLayout(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<div id=\"wrapperdialog\">");
    		AddZeile("<label class=\"fbox1\" id=\"label1\" for=\"t1Id\">input1</label>");
     		AddZeile("<input type=\"text\" class=\"fbox2\" name=\"t1\" id=\"t1Id\" value=\"abc\" size=\"12\" />");
    		AddZeile("<label class=\"fbox1\" id=\"label2\" for=\"t2Id\">input2*********</label>");
    		AddZeile("<input type=\"text\" class=\"fbox2\" name=\"t2\" id=\"t2Id\" value=\"123\" size=\"12\" />");
        	AddZeile("<label class=\"fbox1\" id=\"label3\" for=\"t3Id\">input3</label>");
    		AddZeile("<input type=\"text\" class=\"fbox2\" name=\"t3\" id=\"t3Id\" value=\"123\" size=\"12\" />");
    		AddZeile("</div>");
            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_FieldsetLegend(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<fieldset>");            
            AddZeile("  <legend>Überschrift</legend>");            
            AddZeile("</fieldset>");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_Label(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<label> Username  ");            
            AddZeile("  <!-- hier ein Formular-Element eintragen -->  ");            
            AddZeile("</label>  ");            
            AddZeile("<br />");            
            AddZeile("<br />");            
            AddZeile("  ");            
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertForm_Textfeld(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<input type=\"text\" name=\"name1\"  value=\"Vorgabetext\" size=\"12\"  />");            
            InsertZeile(editor, sAddZeile);
        }
                        
        public static void InsertForm_TextfeldProperties(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<input type=\"text\" name=\"name1\" placeholder=\"Vorgabetext(placeholder)\" value=\"Vorgabetext\" size=\"12\"   autofocus=\"autofocus\"  required=\"required\"/>");            
            InsertZeile(editor, sAddZeile);
        }
              
        public static void InsertForm_TextfeldPattern(JTextArea editor)       {
            sAddZeile = "";
            AddZeile("<!--  IP-Adresse  pattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" --> ");
            AddZeile("<!--  Name: pattern=\"[A-Z][a-z]{1,30}\" --> ");            
            AddZeile("<input type=\"text\" name=\"name1\" placeholder=\"Vorgabetext(placeholder)\" pattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" value=\"Vorgabetext\" size=\"12\"   autofocus=\"autofocus\"  required=\"required\"/>");            
            AddZeile("  ");       
            InsertZeile(editor, sAddZeile);
        }
                        
            
        public static void InsertForm_Textarea(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<br />");
            AddZeile("<!-- Moegliche Varianten von warp: a)off b)HARD  c)SOFT -->");
            AddZeile("<textarea name=\"editor\" rows=\"10\" cols=\"50\"  wrap=\"SOFT\"> Eingabe eines Textes in einem Editor</textarea>");
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertForm_Hidden(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<input type=\"hidden\" name=\"geheim\" value=\"passwort\" size=\"12\"/>");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_CheckBox(JTextArea editor)       {
            sAddZeile = "";
            AddZeile("<input type=\"checkbox\" name=\"cad1\" value=\"CAD1\" /> AutoCAD<br />");            
            InsertZeile(editor, sAddZeile);
        }
                        
        public static void InsertForm_MultiCheckBox(JTextArea editor)       {
            sAddZeile = "";
            AddZeile("<input type=\"checkbox\" name=\"cad[]\" value=\"CAD1\" /> AutoCAD<br />");            
            InsertZeile(editor, sAddZeile);
        }
              
        public static void InsertForm_RadioButton(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("<br />");    
            AddZeile("<input type=\"radio\" name=\"R1\" value=\"CAD1\" checked=\"checked\" /> AutoCAD  <br />");    
            AddZeile("<input type=\"radio\" name=\"R1\" value=\"CAD2\"  /> TurboCAD <br />");    
            AddZeile("<input type=\"radio\" name=\"R1\" value=\"CAD3\"  /> Eagle<br />");    
            AddZeile("");    
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertForm_ComboBox(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("<br />");            
            AddZeile("<select name=\"objekte\" >");            
            AddZeile("  <option > Circle </option >");            
            AddZeile("  <option selected=\"selected\" > Square </option >");            
            AddZeile("  <option  > Polygon </option >");            
            AddZeile("</select>");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertForm_HTML5_Number(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("1. Zahl <input type=\"number\" name=\"zahl1\" value=\"zahl1\" /> <br />");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_HTML5_Range(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<input type=\"range\" name=\"range1\" min=\"10\" max=\"100\" step=\"5\" value=\"55\" />");            
            AddZeile("<output name=\"range1_output\" onforminput=\"value=range1.value\"> 55 </output> <br />");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_HTML5_Color(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("Farbdialog: <input type=\"color\" name=\"color1\" value=\"color1\" /> <br />");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
                        
              
        public static void InsertForm_HTML5_Date(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile(" 1. Datum: <input type=\"date\" name=\"datum1\" value=\"datum1\" /><br />");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
                        
        public static void InsertForm_EventsOnClick(JTextArea editor, String text)     {
        	InsertText(editor, text);
            //sAddZeile = "";
        	//AddZeile(text );            
        	//InsertZeile(editor, sAddZeile);
        }
        public static void InsertForm_OnDblClick(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("ondblclick=\"myDblClick()\"" );            
            InsertZeile(editor, sAddZeile);
        }
        
        
             
        public static void InsertForm_Submit(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("<input type=\"submit\" value=\"senden\" />");            
            InsertZeile(editor, sAddZeile);
        }
                        
        
        public static void InsertForm_SubmitFormAction(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("<input type=\"submit\" value=\"senden\"  formaction=\"page1.xhtml\" formmethod=\"get\"   />");            
            InsertZeile(editor, sAddZeile);
        }
              
        public static void InsertForm_Button(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("<input type=\"button\" value=\"senden\" onclick=\"calc(this.form)\"/>");            
            InsertZeile(editor, sAddZeile);
        }
                        
             
        public static void InsertForm_Reset(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("<input type=\"reset\" value=\"L&#246;schen\"/><br />");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertForm_onSubmitEvent(JTextArea editor)     {
            InsertText(editor, " onsubmit=\"return validation()\" ");
        }

        public static void InsertForm_CompletSample(JTextArea editor)
        {
            sAddZeile = "";

            AddZeile("<form>");
            AddZeile("  <fieldset>");
            AddZeile("   <legend>Überschrift</legend>");
            AddZeile("   <label> Eingabe");
            AddZeile("     <input type=\"text\" name=\"eingabe\"  placeholder=\"Vorgabetext(placeholder)\" value=\"Vorgabetext\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\"  required=\"required\" />");
            AddZeile("   </label>");
            AddZeile("   <br />");
            AddZeile("   <br />");
            AddZeile("   <input type=\"submit\" value=\"senden\" />");
            AddZeile("  <input type=\"reset\" value=\"L&#246;schen\"/><br />");
            AddZeile("  <br />");
            AddZeile(" </fieldset>");
            AddZeile("</form>");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_InsertRange(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("    <script type=\"text/javascript\">");            
            AddZeile("       // <![CDATA[");            
            AddZeile("      \"use strict\"");       
            AddZeile("      function  calc( form ) {");            
            AddZeile("        \"use strict\"");
            AddZeile("         alert (\"hier in f\") ;");            
            AddZeile("      }");       
            AddZeile("      // ]]>");            
            AddZeile("    </script>");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }

        public static void JavaScript_FormArray(JTextArea editor)      {
        	InsertZeile(editor, "let form = document.forms[0];");
        }
        public static void JavaScript_JavaScript_validation(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("function  validation( ) {");
            AddZeile("  \"use strict\"");
            AddZeile("  let form = document.forms[0];");
            AddZeile("  // tests");
            AddZeile("  alert('hier in validation');");            
            AddZeile("  return true;");
            AddZeile("}");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }
              
        public static void InsertJavaScript_Function(JTextArea editor)      {
            FInsertJavaFunction form = new FInsertJavaFunction(null);            
            
            if (form.bResult) {
                String sName = form.getFunctionname();
                sAddZeile = "";
                AddZeile("function "+sName+"() {");
                AddZeile("  \"use strict\"");
                AddZeile("");
                AddZeile("  return;");
                AddZeile("}");
                AddZeile("");
                InsertZeile(editor, sAddZeile);
            }
        }

        public static void InsertJavaScriptFile(JTextArea editor, String filename)    {
            sAddZeile = "";
            AddZeile("<script type=\"text/javascript\" src=\""+filename+"\"></script>"+lineseparator);            
            InsertZeile(editor, sAddZeile);
        }
             
        public static void InsertJavaScript_Consolelog(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("console.log( \"hier beim Punkt1\" );");            
            InsertZeile(editor, sAddZeile);
        }

             
        public static void InsertJavaScript_Event_onload(JTextArea editor)
        {
            InsertText(editor, "onLoad=\"\"");
        }

             
        public static void InsertJavaScript_Event_onUnload(JTextArea editor)
        {
            InsertText(editor, "onUnload=\"\"");
        }

             
        public static void InsertJavaScript_Event_onClick(JTextArea editor)
        {
            InsertText(editor, "onClick=\"\"");
        }

             
        public static void InsertJavaScript_onDblclick(JTextArea editor)
        {
            InsertText(editor, "onDBLclick=\"\"");
        }

             
        public static void InsertJavaScript_Event_onMouseDown(JTextArea editor)
        {
            InsertText(editor, "onMouseDown=\"\"");
        }

            
        public static void InsertJavaScript_Event_onMouseUp(JTextArea editor)
        {
            InsertText(editor, "onMouseUp=\"\"");
        }

            
        public static void InsertJavaScript_Event_onMouseOver(JTextArea editor)
        {
            InsertText(editor, "onMouseOver=\"\"");
        }

            
        public static void InsertJavaScript_Event_onMouseMove(JTextArea editor)
        {
            InsertText(editor, "onMouseMoveonLoad=\"\"");
        }

            
        public static void InsertJavaScript_Event_onMouseOut(JTextArea editor)
        {
            InsertText(editor, "onMouseOut=\"\"");
        }

            
        public static void InsertJavaScript_Event_onFocus(JTextArea editor)
        {
            InsertText(editor, "onFocus=\"\"");
        }

            
        public static void InsertJavaScript_Event_onBlur(JTextArea editor)
        {
            InsertText(editor, "onBlur=\"\"");
        }

            
        public static void InsertJavaScript_Event_onKeypress(JTextArea editor)
        {
            InsertText(editor, "onKeypress=\"\"");
        }

            
        public static void InsertJavaScript_Event_onKeydown(JTextArea editor)
        {
            InsertText(editor, "onKeydown=\"\"");
        }

            
        public static void InsertJavaScript_Event_onKeypup(JTextArea editor)
        {
            InsertText(editor, "onKeyup=\"\"");
        }

            
        public static void InsertJavaScript_Event_onSubmit(JTextArea editor)
        {
            InsertText(editor, "onSubmit=\"\"");
        }

            
        public static void InsertJavaScript_Event_onReset(JTextArea editor)
        {
            InsertText(editor, "onReset=\"\"");
        }

            
        public static void InsertJavaScript_Event_onSelect(JTextArea editor)
        {
            InsertText(editor, "onSelect=\"\"");
        }

            
        public static void InsertJavaScript_Event_onChange(JTextArea editor)
        {
            InsertText(editor, "onChange=\"\"");
        }

        // InsertText(editor, text);
     public static void InsertJavaScript_getElementById(JTextArea editor)     {
            InsertText(editor, "let element = document.getElementById(\"id\");"+lineseparator);
        }

     public static void InsertJavaScript_getElementByClassName(JTextArea editor)     {
         InsertText(editor, "let elements = document.getElementsByClassName(\"myclass\");"+lineseparator );
     }
     
     public static void InsertJavaScript_getElementByName(JTextArea editor)     {
         InsertText(editor, "let elements = document.getElementsByName(\"checkboxgroupid\");"+lineseparator );
     }
     public static void InsertJavaScript_getElementByTagName(JTextArea editor)     {
         InsertText(editor, "let elements = document.getElementsByTagName(\"li\");"+lineseparator );
     }
     public static void InsertJavaScript_innerHTML(JTextArea editor)     {
         sAddZeile = "";
         AddZeile("element.innerHTML = '<h2>Hier ist eine Überschrift</h2>';" );            
         AddZeile("element.innerHTML = 'element.style.display = 'block'; // Einschalten" );            
         AddZeile("element.style.display = 'none';  // Ausschalten" );            
         InsertZeile(editor, sAddZeile);
     }
     public static void InsertJavaScript_JsonForEachLoop1(JTextArea editor)     {
         sAddZeile = "";
         AddZeile("\tfor (let i in objs) {" );            
         AddZeile("\t\t\t" );            
         AddZeile("\t\t}" );            
         AddZeile("\t}" );            
         InsertZeile(editor, sAddZeile);
     }
     public static void InsertJavaScript_JsonForEachLoop2(JTextArea editor)     {
         sAddZeile = "";
         AddZeile("\tfor (let item of objs) {" );            
         AddZeile("\t\t\t" );            
         AddZeile("\t\t}" );            
         AddZeile("\t}" );            
         InsertZeile(editor, sAddZeile);
     }
     
     public static void InsertJavaScript_AjaxStruktur(JTextArea editor, String xmlhttp)     {
    	  sAddZeile = "";
    	  AddZeile("<script type=\"text/javascript\">");
    	  AddZeile("// <![CDATA[");
    	  AddZeile("\"use strict\";");
    	  AddZeile("");

    	  AddZeile("let "+xmlhttp+" = new XMLHttpRequest();");
    	  AddZeile("xmlhttp1.onreadystatechange = receiveJson;  // Funktionspointer");
    	  AddZeile("");


    	  AddZeile("function startAjax(form) {");
    	  AddZeile("\t\"use strict\";");
    	  AddZeile("\tlet param = 'Ajaxb.php?Wert=' + 123 + '&Name=' + 'abc';");
    	  AddZeile("\talert(param);");
    	  AddZeile("\txmlhttp1.open(\"GET\", param);");
    	  AddZeile("\txmlhttp1.send();");
    	  AddZeile("}  // startAjax");

    	  AddZeile("");

    	  AddZeile("function receiveJson() {");
    	  AddZeile("\t\"use strict\";");
    	  AddZeile("\t// alert(xmlhttp1.readyState);");
    	  AddZeile("\tif (xmlhttp1.readyState == 4) {");
    	  AddZeile("\t\tlet elementAjax = document.getElementById(\"ajax\");");
    	  AddZeile("\t\talert(xmlhttp1.responseText);");
    	  AddZeile("\t\t//elementAjax.innerHTML= xmlhttp1.responseText;");
    	  AddZeile("\t\t// let obj = JSON.parse(xmlhttp1.responseText);");
    	  AddZeile("\t\t//elementAjax.innerHTML = \"<h2> Ajax Text </h2> \";");
    	  AddZeile("\t}  // if");
    	  AddZeile("}  //receiveJson");

    	  AddZeile("");

    	  AddZeile("// ]]>");
    	  AddZeile("</script>");    	  
    	  InsertZeile(editor, sAddZeile);
     }
            
        public static void mnJavaScript_Access_multicheckbox(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tlet checkboxes=document.getElementsByName('chkgroup');");            
            AddZeile("\t\t\tfor (let i=0; i<checkboxes.length; i++) {");            
            AddZeile("\t\t\t\tif (checkboxes[i].checked) {");            
            AddZeile("\t\t\t\t  // checkboxes[i].value");            
            AddZeile("\t\t\t}");            
            InsertZeile(editor, sAddZeile);
        }

        public static void mnJavaScript_AccessRadiobutton(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tlet select=\"\";");            
            AddZeile("\t\t\tfor (let i=0; i<form.rb.length; i++) {");            
            AddZeile("\t\t\t\tif (form.rb[i].checked) {");            
            AddZeile("\t\t\t\t\tselect = form.rb[i].value;");            
            AddZeile("\t\t\t\t}  // if");            
            AddZeile("\t\t\t}");            
            InsertZeile(editor, sAddZeile);
        }

        
        public static void mnJavaScript_Access_comboboxSingle(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tindex = form.myCombobox.selectedIndex;  // form.myCombobox.options[i].value");
            InsertZeile(editor, sAddZeile);
        }

        
        public static void mnJavaScript_Access_comboboxMultiple(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tlet select = form.elements['selectFunctions[]'];");            
            AddZeile("\t\t\tif (select.selectedOptions.length <= 0) {");            
            AddZeile("\t\t\t\t\talert('Bitte mindestens eine Operation auswählen!');");            
            AddZeile("\t\t\t\t\treturn false;");            
            AddZeile("\t\t\t}  // if");            
            InsertZeile(editor, sAddZeile);
        }

        
        public static void InsertJavaScript_If(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("if() {");            
            AddZeile("");            
            AddZeile("}");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertJavaScript_If_Else(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("if() {");
            AddZeile("");
            AddZeile("}");
            AddZeile("else {");            
            AddZeile("");            
            AddZeile("}");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertJavaScript_Dowhile(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("do {");
            AddZeile("");
            AddZeile("} while();");
            InsertZeile(editor, sAddZeile);
        }

            
        public static void InsertJavaScript_While(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("while() {");
            AddZeile("");
            AddZeile("}");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }


       

        public static void InsertJavaScript_For_i(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("for (i=; i< ; i++ ) {");            
            AddZeile("");            
            AddZeile("}");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
 
        public static void InsertJavaScript_Foreach(JTextArea editor)       {
            sAddZeile = "";
            AddZeile("for (let i in objs) {");            
            AddZeile("");            
            AddZeile("}");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertJavaScript_ForeachOf(JTextArea editor)       {
            sAddZeile = "";
            AddZeile("for (let item of objs) {");            
            AddZeile("");            
            AddZeile("}");            
            AddZeile("");            
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertJavaScript_Switch(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("switch () {");
            AddZeile("  case 0:");
            AddZeile("         break;");
            AddZeile("  case 1:");
            AddZeile("         break;");
            AddZeile("  default:");
            AddZeile("         break;");
            AddZeile("}");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_ParseInt(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("var n = parseInt(sn);");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_ParseFloat(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("var n = parseInt(sn,10);");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_isNaN(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("if ( isNaN(sn) ) {");
            AddZeile("");
            AddZeile("}");
            AddZeile("");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_komma2Point(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("sn = sn.replace( /,/,\".\" );");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_toFixed(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("var erg = x.toFixed(3);");            
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertJavaScript_split(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("var musik = \"Abba;Beatles;Zappa\";");            
            AddZeile("var values = musik.split(\";\")");            
            AddZeile("var erg1 = values[0];");            
            AddZeile("var erg2 = values[1];");         
            AddZeile("var erg3 = values[2];");            
            AddZeile("");         
            InsertZeile(editor, sAddZeile);
        }

        public static void mnJavaScript_Arrays_createMultidimArray(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\tfunction MyClass (x,y) {");            
            AddZeile("\t\t\tthis.x = x;");            
            AddZeile("\t\t\tthis.y = y;");            
            AddZeile("");
            AddZeile("\t\t\tthis.sysoX = function () {\")");            
            AddZeile("\t\t\t\talert('x:'+this.x);");            
            AddZeile("\t\t\t}");
            AddZeile("");
            AddZeile("\t\t\tthis.getX = function () {");            
            AddZeile("\t\t\t\treturn this.x;");            
            AddZeile("\t\t\t}");
            AddZeile("");
            AddZeile("\t\t\tthis.setX = function (x) {");            
            AddZeile("\t\t\t\tthis.x=x;");            
            AddZeile("\t\t\t}");
            AddZeile("");
            AddZeile("\t\t} // MyClass");
            AddZeile("");
            AddZeile("\t\t\t// used: ");
            AddZeile("\t\t\tlet instance = new MyClass ();");
            InsertZeile(editor, sAddZeile);
        }
        
        public static void mnJavaScript_Class_createClass(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tMyClass.color='blue';");         
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertJavaScript_Regex(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t\t\tlet regex = new RegExp('^[A-ZÄÖÜ]{1,1}[a-zäüöß]{1,29}$');");         
            AddZeile("\t\t\t\tif (!regex.test(form.firstname.value)) {");         
            AddZeile("\t\t\t\t\talert('Fehlerhafter Vorname');");         
            AddZeile("\t\t\t\treturn;");         
            AddZeile("\t\t\t}");         
            InsertZeile(editor, sAddZeile);
        }

        

        public static void InsertJavaScript_Popupwindow(JTextArea editor)
        {
           // error
        }

        
        public static void InsertPHP_Range(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("<?php");
            AddZeile("");
            AddZeile("");
            AddZeile("?>");           
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertPHP_Funktion(JTextArea editor)    {
            FInsertPHPFunction form = new FInsertPHPFunction(null);       
            if (form.bResult) {
                String sName = form.getFunctionname();
                sAddZeile = "";
                AddZeile("function "+sName+"() {");
                AddZeile("");
                AddZeile("  return;");
                AddZeile("}");
                AddZeile("");
                InsertZeile(editor, sAddZeile);
            }
        }

        public static void PHP_InsertPHP_isset(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("if ( isset($_GET[''vorname'']) ){		 //	Ist gesetzt?");
            AddZeile("  $vorname = $_GET[''vorname''];");
            AddZeile("}");                        
            InsertZeile(editor, sAddZeile);
        }
        
        public static void mnPHP_InsertPHP_issetSelectMultiple(JTextArea editor)     {
            sAddZeile = "";
            AddZeile("\t// the name of the select ui-element must have a '[]'");
            AddZeile("\t$liste = array();");
            AddZeile("\tif ( isset($_GET['liste']) ){   // Is the list gesetzt?");
            AddZeile("\t\tforeach ($_GET['prfs'] as $item) {");
            AddZeile("\t\t\t$liste[] = $item;");
            AddZeile("\t\t}");
            AddZeile("\telse {");
            AddZeile("\t\t$ok =false;");
            AddZeile("\t$error.=\\\"Error: Der Parameter 'liste' wurde nicht übergeben<br />\\\";");
            AddZeile("\t}");
            InsertZeile(editor, sAddZeile);
        }
        
        
        public static void InsertPHP_Isnumeric(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  if (is_numeric($sZahl)) {");
            AddZeile("     $zahl = intval ( $str_zahl, 10 );");
            AddZeile("  } else {");
            AddZeile("     echo \"Konvertierungsfehler: Die Variable '???' ist keine Zahl\", PHP_EOL;");
            AddZeile("  }");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertPHP_IsInt(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  if (is_int($sZahl)) {");
            AddZeile("     $zahl = intval ( $str_zahl, 10 );");
            AddZeile("  } else {");
            AddZeile("     echo \"Konvertierungsfehler: Die Variable '???' ist keine Zahl\", PHP_EOL;");
            AddZeile("  }");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertPHP_IsFloat(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  if (is_float($sZahl)) {");
            AddZeile("     $zahl = floatval ( $str_zahl, 10 );");
            AddZeile("  } else {");
            AddZeile("     echo \"Konvertierungsfehler: Die Variable '???' ist keine Zahl\", PHP_EOL;");
            AddZeile("  }");
            InsertZeile(editor, sAddZeile);
        }
              
        public static void InsertPHP_IntVal(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("  $zahl = intval ( $str_zahl );");
            InsertZeile(editor, sAddZeile);
        }
        public static void InsertPHP_FloatVal(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("  $zahl = floatval ( $str_zahl );");
            InsertZeile(editor, sAddZeile);
        }

        
        public static void PHP_InsertClassResult(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("class Result {");
            AddZeile("\tpublic $zahl=0;");
            AddZeile("\tpublic $$error='';");
            AddZeile("\tpublic $$result=true;");
            AddZeile("\tpublic function  __construct($zahl) {");
            AddZeile("\t\t$this->zahl = $zahl;");
            AddZeile("\t}");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_InsertClassNumber(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("class Number {");
            AddZeile("\tpublic $zahl=0;");
            AddZeile("\tpublic function  __construct($zahl) {");
            AddZeile("\t\t$this->zahl = $zahl;");
            AddZeile("\t}");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        
        public static void PHP_Attribute(JTextArea editor, String attrib)      {
        	String attriblower = attrib.toLowerCase();
        	attrib = attriblower.substring(0,1) + attrib.substring(1);
            sAddZeile = "";
            AddZeile("\tprivate $" + attrib+";");
            AddZeile("\tpublic function get" + attrib + "() {");
            AddZeile("\t\treturn $this->" + attrib + ";");
            AddZeile("\t}");
            AddZeile("");
            AddZeile("\tpublic function set" + attrib + "($value) {");
            AddZeile("\t\t$this->" + attrib + "=$value;");
            AddZeile("\t}");
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertPHPFile(JTextArea editor, String filename)    {
            sAddZeile = "";
            AddZeile("include('" + filename+ "');"+Konst.NL);            
            InsertZeile(editor, sAddZeile);
        }        

        public static void PHP_JSon_encodepur(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\treturn json_encode(...);");
            InsertZeile(editor, sAddZeile);
        }
        public static void PHP_JSon(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("private function processArray($array)  {");
            AddZeile("\tforeach ($array as $key => $value) {");
            AddZeile("\t\tif (is_object($value)) {");
            AddZeile("\t\t\t$array[$key] = $value->toArray();");
            AddZeile("\t\t}  // if");
            AddZeile("\t\tif (is_array($value)) {");
            AddZeile("\t\t\t$array[$key] = $this->processArray($value);");
            AddZeile("\t\t}");
            AddZeile("\t} // foreach");
            AddZeile("\t// If the property isn't an object or array, leave it untouched\"");
            AddZeile("}");
            AddZeile("");
            AddZeile("public function toArray()  {");
            AddZeile("\treturn $this->processArray(get_object_vars($this));");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
        public static void PHP_json_encode(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t$ergebnis = json_encode($std->toArray());");
            InsertZeile(editor, sAddZeile);
        }
        
        // -----------------------------------------------------------
        public static void PHP_If(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("if() {");
            AddZeile("");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
			
			
	        public static void PHP_If_Else(JTextArea editor)      {
	            sAddZeile = "";
	            AddZeile("if() {");
	            AddZeile("");
	            AddZeile("}");
	            AddZeile("else {");
	            AddZeile("");
	            AddZeile("}");
	            InsertZeile(editor, sAddZeile);
	        }

		
        public static void PHP_If_ok_Else(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("if($ok) {");
            AddZeile("");
            AddZeile("}");
            AddZeile("else {");
            AddZeile("");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }		
		
        public static void PHP_Dowhile(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("do {");
            AddZeile("");
            AddZeile("} while();");
            InsertZeile(editor, sAddZeile);
        }
		
		
        public static void PHP_While(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("while () {");
            AddZeile("");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
		
        public static void PHP_Foreach(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("foreach ($liste as $item) {");
            AddZeile("");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }
	
	
    public static void PHP_For_i(JTextArea editor)      {
        sAddZeile = "";
        AddZeile("for ($i=$n; $i<$n ; $i++ ) {");
        AddZeile("");
        AddZeile("}");
        InsertZeile(editor, sAddZeile);
    }
		        
    public static void PHP_Switch(JTextArea editor)      {
        sAddZeile = "";
        AddZeile("switch ($???) {");
        AddZeile("  case 0:");
        AddZeile("         break;");
        AddZeile("  case 1:");
        AddZeile("         break;");
        AddZeile("  default:");
        AddZeile("         break;");
        AddZeile("}");
        AddZeile("");        
        InsertZeile(editor, sAddZeile);
    }
		        
        
        // ------------------------------------------------------------
        
        public static void PHP_Arrays_createArray(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("xxxxxxxxxxx");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_Arrays_createArrayWithItems(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t $feld = array(\"red\", \"blue\", \"green\");");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_Arrays_createMultidimArray(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t$colors = array");
            AddZeile("\t(");
            AddZeile("\t\tarray('green',0,0,255),");
            AddZeile("\t\tarray('red',255,0,0),");
            AddZeile("\t\tarray('lightgray',200,200,200),");
            AddZeile("\t\tarray('orange',255,128,0)");
            AddZeile("\t};");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_Arrays_pushArray(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t$feld[] = \"newItem\";");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_Arrays_arrayLength(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t$numberOfElements = count($feld)");
            InsertZeile(editor, sAddZeile);
        }

        public static void PHP_Arrays_foreach(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\tforeach ($feld as $item) {");
            AddZeile("\t\techo $item . '<br />';");
            AddZeile("\t}");
            InsertZeile(editor, sAddZeile);
        }
        
        
        public static void PHP_regex(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("\t$match = '^[A-ZÄÖÜ]{1,1}[a-zäüöß]{1,29}$';");
            AddZeile("\tif(!preg_match($match, $lastname)) {");
            AddZeile("\t\techo 'Fehlerhafter Nachname';");
            AddZeile("\t}");
            InsertZeile(editor, sAddZeile);
        }
        
        public static void InsertPHP_echoText(JTextArea editor)      {
            sAddZeile = "";
            AddZeile("  echo \"<p>Hier kommt ein Text in der HTML-Datei</p>\",PHP_EOL;");
            InsertZeile(editor, sAddZeile);
        }

              
        public static void InsertPHP_echoStringAndVariable(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  $zahl=42;");
            AddZeile("  echo \"<p>Zahl: $zahl</p>"+lineseparator+",PHP_EOL;");
            InsertZeile(editor, sAddZeile);
        }

              
        public static void InsertPHP_echoStringAndVariable_withPoint(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  $zahl=42;");
            AddZeile("  echo \"<p>Zahl: \" . $zahl . \"</p>\",PHP_EOL;");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertPHP_weiterleitung(JTextArea editor)   {
            sAddZeile = "";
            AddZeile("  header('location:nextHtml.xhtlm');");
            AddZeile("  exit(1);");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_PositionAbsolute(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  position: absolute;");
            AddZeile("  top: 50px;");
            AddZeile("  left: 5;");
            AddZeile("  width: 250px;");
            InsertZeile(editor, sAddZeile);
        }

        public static void InsertCSS_PositionRelativ(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("  position: relative;");
            AddZeile("  top: 50px;");
            AddZeile("  left: 5;");
            AddZeile("  width: 250px;");
            InsertZeile(editor, sAddZeile);
        }



        public static void InsertCSS_Multidefinition(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("h1, h2 {");
            AddZeile("  color: #0000FF;");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }


        public static void InsertCSS_SelektorenBehind(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("body > h2 {");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }



        public static void InsertCSS_SelektorenTopDown(JTextArea editor)
        {
            sAddZeile = "";
            AddZeile("h1 + h2 {");
            AddZeile("}");
            InsertZeile(editor, sAddZeile);
        }



        public static void InsertCSS_SelektorenTogether(JTextArea editor)
        {
              sAddZeile = "";
              AddZeile("/*  <div id=\"left\">  */");
              AddZeile("#left{");              
              AddZeile("  float: left;");
              AddZeile("  left: 0;");
              AddZeile("  width: 11em;");
              AddZeile("  margin-left: 5px;  /* Rand wird aufgeteilt */"); 
              AddZeile("  margin-right: 5px;");
              AddZeile("  padding: 5px; /* Innenrand, sieht besser aus */");
              AddZeile("  border: 1px inset  black;");
              AddZeile("}");
              AddZeile("");


              AddZeile("/*  <div id=\"right\">  */");
              AddZeile("#right{");
              AddZeile("  float: left;");
              AddZeile("  margin-left: 5px;  /* Rand wird aufgeteilt */"); 
              AddZeile("  margin-right: 5px;");
              AddZeile("  padding: 5px; /* Innenrand, sieht besser aus */");
              AddZeile("  width: 300px;");
              AddZeile("  margin-left: 5px;");
              AddZeile("  border: 1px inset  black;");
              AddZeile("}");
              AddZeile("");
              InsertZeile(editor, sAddZeile);
        }


        
}
