import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

import javax.swing.border.*;

public class FRadio3 extends JDialog {
  
 public static final int C_HTMLCSS = 1;
 public static final int C_PHPHTML = 2;  
 public static final int C_PHPPUR = 3;  
 public static final int C_JAVASCRIPT = 4;
  
  public boolean bResult=false;
  public int iNeuerDateiTyp=0;  
  
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Cancel");

  private JRadioButton rbXHTML_CSS = new JRadioButton("XHTML und CSS-File", true);
  private JRadioButton rbPHPHTML = new JRadioButton("PHP-File (HTML)", false);
  private JRadioButton rbPHPPur = new JRadioButton("PHP-File (Pur)", false);
  private JRadioButton rbJAVASCRIPT = new JRadioButton("Javascript-File", false);
  
  public FRadio3(Frame parent) {
    super(parent);	// oder super(parent, true);
    setModal(true);
    bResult=false;
    setSize(400, 350);
    setTitle("Select a new file");
    // setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
    setVisible(true);
  }

  private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );
    JLabel label1 = new JLabel("Select a new file");
    label1.setFont( new Font("Arial", Font.BOLD,20)  );
    label1.setForeground(Color.BLUE);
    this.getContentPane().add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));
    
    JPanel panel1 = new JPanel();
    panel1.setLayout ( new GridBagLayout() ); 
    panel1.add( rbXHTML_CSS,
       new GridBagConstraints(0, 0, 1, 1, 0.0, 10.0,
         GridBagConstraints.WEST, GridBagConstraints.VERTICAL,
         new Insets(10,0,0,120), 0, 0));
    panel1.add( rbPHPHTML,
       new GridBagConstraints(0, 1, 1, 1, 0.0, 10.0,
         GridBagConstraints.WEST, GridBagConstraints.VERTICAL,
         new Insets(10,0,0,120), 0, 0));
    panel1.add( rbPHPPur,
    	       new GridBagConstraints(0, 2, 1, 1, 0.0, 10.0,
    	         GridBagConstraints.WEST, GridBagConstraints.VERTICAL,
    	         new Insets(10,0,0,120), 0, 0));
    panel1.add( rbJAVASCRIPT,
    	       new GridBagConstraints(0, 3, 1, 1, 0.0, 10.0,
    	         GridBagConstraints.WEST, GridBagConstraints.VERTICAL,
    	         new Insets(10,0,0,120), 0, 0));

   TitledBorder tb;
    tb = new TitledBorder( LineBorder.createBlackLineBorder(),
            "Type of the files");
   panel1.setBorder(tb);
   //panel1.setBackground(Color.yellow);
    
    rbXHTML_CSS.setFont( new Font("Arial", Font.BOLD,14)  );
    rbPHPHTML.setFont( new Font("Arial", Font.BOLD,14)  );
    rbPHPPur.setFont( new Font("Arial", Font.BOLD,14)  );
    rbJAVASCRIPT.setFont( new Font("Arial", Font.BOLD,14)  );
    tb.setTitleFont( new Font("Arial", Font.BOLD,14)  );
    tb.setTitleColor(Color.blue);
    
    
    this.getContentPane().add( panel1,
       new GridBagConstraints(
           0, 1, 1, 1, 100.0, 100.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.BOTH,
         new Insets(10,0,0,0), 0, 0));
    
    
    JPanel panelBn = new JPanel();
    panelBn.setLayout( new FlowLayout() );
    panelBn.add(bnOk);
    panelBn.add(bnEsc);  
    bnOk.setFont( new Font("Arial", Font.BOLD,16)  );
    bnOk.setPreferredSize( bnEsc.getPreferredSize() );
    bnEsc.setFont( new Font("Arial", Font.BOLD,16)  );
    

    this.getContentPane().add(panelBn,
       new GridBagConstraints(
           0,2, 1, 1, 100.0, 0.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.HORIZONTAL,
         new Insets(20,0,10,0), 0, 0));  // Top left Bottom Right
     
    bnOk.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnOK_click();
      }
    });
    bnEsc.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnEsc_click();
      }
    });     
    ButtonGroup group1 = new ButtonGroup();
    group1.add(rbXHTML_CSS);
    group1.add(rbPHPHTML);
    group1.add(rbPHPPur);
    group1.add(rbJAVASCRIPT);    
      
    
  }  // setGUI

  private void  bnOK_click() {
    bResult=true;
    if (rbXHTML_CSS.isSelected()) iNeuerDateiTyp=C_HTMLCSS;
    if (rbPHPHTML.isSelected())       iNeuerDateiTyp=C_PHPHTML;
    if (rbPHPPur.isSelected())       iNeuerDateiTyp=C_PHPPUR;
    if (rbJAVASCRIPT.isSelected())     iNeuerDateiTyp=C_JAVASCRIPT;
    setVisible(false);
    dispose();
  }

  private void  bnEsc_click() {
    bResult=false;
    setVisible(false);
    dispose();
  }
  
  
  
}
