import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class FSelectColorConstant  extends JDialog{
  
  private String[] sItems = {"white", "red", "blue", "black", "green", "yellow",
                    "cyan", "magenta", "purple", "navy", "olive",
                    "lime", "aqua", "teal", "silver", "maroon" };
  
  public boolean bResult=false;
  
  public String sColor="";
  
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Abbruch");

  private JPanel panel1 = new JPanel();
  private JPanel colorPanel = new JPanel();
  private JList listBox1;
  
  
  public FSelectColorConstant(Frame parent) {
    super(parent);	// oder super(parent, true);
    setModal(true);
    bResult=false;
    setSize(250, 400);
    setTitle("Auswahl einer Farbkonstante");
    // setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
    setVisible(true);
  }

  private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );
     this.getContentPane().add( new JLabel("Farbe"),
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(20,20,0,0), 0, 0));
     
    
    listBox1 = new JList(sItems);
    listBox1.setSelectedIndex(0);
     
    this.getContentPane().add(new JScrollPane(listBox1),
       new GridBagConstraints(
           0,1, 1, 1, 100.0, 100.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.BOTH,
         new Insets(10,20,10,20), 0, 0));  // Top left Bottom Right

    listBox1.addListSelectionListener(
           new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {           
                    FileListClick();                    
                }
           }
    );

    
    colorPanel.setBackground(Color.white);
    this.getContentPane().add(colorPanel,
       new GridBagConstraints(
           0,2, 1, 1, 100.0, 50.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.BOTH,
         new Insets(0,20,10,20), 0, 0));  // Top left Bottom Right
    
    
    panel1.setLayout( new FlowLayout() );
    panel1.add(bnOk);
    panel1.add(bnEsc);  

    this.getContentPane().add(panel1,
       new GridBagConstraints(
           0,3, 1, 1, 100.0, 0.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.HORIZONTAL,
         new Insets(0,0,10,0), 0, 0));  // Top left Bottom Right
     
    bnOk.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnOK_click();
      }
    });
    bnEsc.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnEsc_click();
      }
    });
    
  }  // setGUI
  
  private void FileListClick() {
    colorPanel.setBackground(Color.yellow);
    switch (listBox1.getSelectedIndex())
    {
        case 0: colorPanel.setBackground(Color.WHITE);
            break;
        case 1: colorPanel.setBackground(Color.RED);
            break;
        case 2: colorPanel.setBackground(Color.BLUE);
            break;
        case 3: colorPanel.setBackground(Color.BLACK);
            break;
        case 4: colorPanel.setBackground(new Color(0x008000) );
            break;
        case 5: colorPanel.setBackground(Color.YELLOW);
            break;
        case 6: colorPanel.setBackground(Color.CYAN);
            break;
        case 7: colorPanel.setBackground(Color.MAGENTA);
            break;
        case 8: colorPanel.setBackground(new Color(0x800080) );
            break;
        case 9: colorPanel.setBackground(new Color(0x000080) );
            break;
        case 10: colorPanel.setBackground(new Color(0x808000) );
            break;
        case 11: colorPanel.setBackground(new Color(0x00FF00) );
            break;
        case 12: colorPanel.setBackground(new Color(0x00FFFF) );
            break;
        case 13: colorPanel.setBackground(new Color(0x008080) );
            break;
        case 14: colorPanel.setBackground(new Color(0xC0C0C0) );
            break;
        case 15: colorPanel.setBackground(new Color(0x800000) );
            break;
    }
  }
  
  private void  bnOK_click() {
    int index = listBox1.getSelectedIndex();
    if (index>=0) {
       sColor = sItems[index];
    }
    bResult=true;
    setVisible(false);
    dispose();
  }

  private void  bnEsc_click() {
    bResult=false;
    setVisible(false);
    dispose();
  }
  
}
