﻿import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.*;
import java.io.File;
import javax.swing.*;

public class HTMLForm extends ChildForm implements ActionListener {

	JMenuBar menuBar1 = new JMenuBar();

	public HTMLForm() {
		this("");
	}

	public HTMLForm(String sFilename) {
		super(sFilename);
		setGUI();
		setVisible(true);
		// installLnF();
	}

	// wird aufgerufen wird Clientfenster, abgeleitet
	private void setGUI() {
		setMenues();		
	}

	private void InsertCSS_ColorConstant_click() {
		Middleware.InsertCSS_ColorConstant(getEditor());
	}

	private void MnInsertGrafik_Click() {
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setMultiSelectionEnabled(false);

		jFileChooser1.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
		jFileChooser1.setCurrentDirectory(new File("D:\\cdaten\\html"));

		jFileChooser1.addChoosableFileFilter(new MyFileFilter("bmp", "BMP-Dateien (*.bmp)"));
		jFileChooser1
				.addChoosableFileFilter(new MyFileFilter(new String[] { "jpg", "jpeg" }, "JPG-Dateien (*.jpg;*.jpeg)"));

		jFileChooser1.addChoosableFileFilter(new MyFileFilter("png", "PNG-Dateien (*.png)"));
		jFileChooser1.addChoosableFileFilter(new MyFileFilter("gif", "GIF-Dateien (*.gif)"));

		jFileChooser1.setPreferredSize(new Dimension(1000, 600));
		jFileChooser1.setDialogTitle("Ein Bild importieren");
		// Okay gedrückt ?
		if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
			String sFilename = jFileChooser1.getSelectedFile().getPath();
			if (Basis.YesNo("Wollen Sie zusätzliche Koordinatenbereiche als Links einfügen?", "Area Shapes"))
				Middleware.InsertHTML_InsertImage(getEditor(), sFilename, true);
			else
				Middleware.InsertHTML_InsertImage(getEditor(), sFilename, false);
		}
	} // MnInsertGrafik_Click

	private void insertMenue(JMenu parent, String sTitle, String sHashValue) {
		MyJMenuItem menu = new MyJMenuItem(sTitle, sHashValue);
		parent.add(menu);
		menu.addActionListener(this);
	}

	public void actionPerformed(ActionEvent e) {
		MyJMenuItem menu = (MyJMenuItem) e.getSource();
		String sValue = menu.HashValue;
		StartCommand(sValue, menu.getText());
	}

	private void StartCommand(String sValue, String Caption) {
		if (sValue.equals("InsertHTML_Basic_XHTML_strict11")) {
			Middleware.InsertHTML_Basic_XHTML_strict11(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Basic_XHTML")) {
			Middleware.InsertHTML_Basic_XHTML(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_HTML4")) {
			Middleware.InsertHTML_HTML4(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Basic_Pur")) {
			Middleware.InsertHTML_Basic_Pur(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Header")) {
			Middleware.InsertHTML_Header(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Paragraph")) {
			Middleware.InsertHTML_Paragraph(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Header3")) {
			Middleware.InsertHTML_Header3(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_UL")) {
			Middleware.InsertHTML_UL(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_OL")) {
			Middleware.InsertHTML_OL(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_Table")) {
			Middleware.InsertHTML_Table(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_TR")) {
			Middleware.InsertHTML_TR(getEditor());
			return;
		}
		if (sValue.equals("InsertHTML_HR")) {
			Middleware.InsertHTML_HR(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FontColor")) {
			Middleware.InsertCSS_FontColor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_ColorConstant_Click")) {
			InsertCSS_ColorConstant_click();
			return;
		}

		if (sValue.equals("InsertHTML_EMailLink")) {
			Middleware.InsertHTML_EMailLink(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Link")) {
			Middleware.InsertHTML_Link(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Anchor")) {
			Middleware.InsertHTML_Anchor(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Comment")) {
			Middleware.InsertHTML_Comment(getEditor());
			return;
		}

		if (sValue.equals("MnInsertGrafik_Click()")) {
			MnInsertGrafik_Click();
			return;
		}

		if (sValue.equals("InsertHTML_Font_Bold")) {
			Middleware.InsertHTML_Font_Bold(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Italic")) {
			Middleware.InsertHTML_Font_Italic(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Underline")) {
			Middleware.InsertHTML_Font_Underline(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_LineThrough")) {
			Middleware.InsertHTML_Font_LineThrough(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Sup")) {
			Middleware.InsertHTML_Font_Sup(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Sub")) {
			Middleware.InsertHTML_Font_Sub(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Space")) {
			Middleware.InsertHTML_Font_Char_Space(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Tab")) {
			Middleware.InsertHTML_Font_Char_Tab(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_CR")) {
			Middleware.InsertHTML_Font_Char_CR(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_LF")) {
			Middleware.InsertHTML_Font_Char_LF(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Blank")) {
			Middleware.InsertHTML_Font_Char_Blank(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Dash")) {
			Middleware.InsertHTML_Font_Char_Dash(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Copyright")) {
			Middleware.InsertHTML_Font_Char_Copyright(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Copyright_R")) {
			Middleware.InsertHTML_Font_Char_Copyright_R(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_Trademark")) {
			Middleware.InsertHTML_Font_Char_Trademark(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_LT")) {
			Middleware.InsertHTML_Font_Char_LT(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_GT")) {
			Middleware.InsertHTML_Font_Char_GT(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_LTLT")) {
			Middleware.InsertHTML_Font_Char_LTLT(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Font_Char_GTGT")) {
			Middleware.InsertHTML_Font_Char_GTGT(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_CSSReferenzExtern")) {
			Middleware.InsertHTML_CSSReferenzExtern(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_CSSReferenzLocal")) {
			Middleware.InsertHTML_CSSReferenzLocal(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Body")) {
			Middleware.InsertCSS_Body(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_xx")) {
			Middleware.InsertCSS_xx(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_H2")) {
			Middleware.InsertCSS_H2(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL")) {
			Middleware.InsertCSS_OL(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_UL")) {
			Middleware.InsertCSS_UL(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TH")) {
			Middleware.InsertCSS_TH(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TH")) {
			Middleware.InsertCSS_TH(getEditor());
			return;
		}

		if (sValue.equals("InsertHTML_Scrolling")) {
			Middleware.InsertHTML_Scrolling(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_background_image")) {
			Middleware.InsertCSS_background_image(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Body_backgroundrepeat")) {
			Middleware.InsertCSS_Body_backgroundrepeat(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Bodybackgroundattachment")) {
			Middleware.InsertCSS_Bodybackgroundattachment(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Body_backgroundposition")) {
			Middleware.InsertCSS_Body_backgroundposition(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_ColorConstant")) {
			Middleware.InsertCSS_ColorConstant(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FontColor")) {
			Middleware.InsertCSS_FontColor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BackgroundColor")) {
			Middleware.InsertCSS_BackgroundColor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FontSize_12em")) {
			Middleware.InsertCSS_FontSize_12em(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FontColor")) {
			Middleware.InsertCSS_FontColor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Fonttyp_Verdana")) {
			Middleware.InsertCSS_Fonttyp_Verdana(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Fonttyp_CourierNew")) {
			Middleware.InsertCSS_Fonttyp_CourierNew(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Fonttyp_Monospace")) {
			Middleware.InsertCSS_Fonttyp_Monospace(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_SmallestFont")) {
			Middleware.InsertCSS_SmallestFont(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_SmallerFont")) {
			Middleware.InsertCSS_SmallerFont(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BiggerFont")) {
			Middleware.InsertCSS_BiggerFont(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BigFont")) {
			Middleware.InsertCSS_BigFont(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FontSize_15Em")) {
			Middleware.InsertCSS_FontSize_15Em(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Bigger_Percentage")) {
			Middleware.InsertCSS_Bigger_Percentage(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_WordSpacing")) {
			Middleware.InsertCSS_WordSpacing(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_LetterSpacing")) {
			Middleware.InsertCSS_LetterSpacing(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_None")) {
			Middleware.InsertCSS_Textdecoration_None(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_Underline")) {
			Middleware.InsertCSS_Textdecoration_Underline(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_Overline")) {
			Middleware.InsertCSS_Textdecoration_Overline(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_linethrough")) {
			Middleware.InsertCSS_Textdecoration_linethrough(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_blink")) {
			Middleware.InsertCSS_Textdecoration_blink(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textdecoration_Italic")) {
			Middleware.InsertCSS_Textdecoration_Italic(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TextTransform_none")) {
			Middleware.InsertCSS_TextTransform_none(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TextTransform_uppercase")) {
			Middleware.InsertCSS_TextTransform_uppercase(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TextTransform_lowercase")) {
			Middleware.InsertCSS_TextTransform_lowercase(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TextTransform_capitalize")) {
			Middleware.InsertCSS_TextTransform_capitalize(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Text_Indent")) {
			Middleware.InsertCSS_Text_Indent(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_UL_listeNone")) {
			Middleware.InsertCSS_UL_listeNone(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_UL_Listecircle")) {
			Middleware.InsertCSS_UL_Listecircle(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_UL_Listesquare")) {
			Middleware.InsertCSS_UL_Listesquare(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_UL_Listedisc")) {
			Middleware.InsertCSS_UL_Listedisc(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_ListeNone")) {
			Middleware.InsertCSS_OL_ListeNone(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listedecimal")) {
			Middleware.InsertCSS_OL_Listedecimal(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listedecimalleadingzero")) {
			Middleware.InsertCSS_OL_Listedecimalleadingzero(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listelowerroman")) {
			Middleware.InsertCSS_OL_Listelowerroman(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listeupperroman")) {
			Middleware.InsertCSS_OL_Listeupperroman(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listelowergreek")) {
			Middleware.InsertCSS_OL_Listelowergreek(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listeuppergreek")) {
			Middleware.InsertCSS_OL_Listeuppergreek(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_Listelowerlatin")) {
			Middleware.InsertCSS_OL_Listelowerlatin(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_OL_ListeUpperlatin")) {
			Middleware.InsertCSS_OL_ListeUpperlatin(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_ListStylePosition_inside")) {
			Middleware.InsertCSS_ListStylePosition_inside(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_ListStylePosition_outside")) {
			Middleware.InsertCSS_ListStylePosition_outside(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TH")) {
			Middleware.InsertCSS_TH(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TD")) {
			Middleware.InsertCSS_TD(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_TableBorderTDTHTable")) {
			Middleware.InsertCSS_TableBorderTDTHTable(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Bordercolor")) {
			Middleware.InsertCSS_Bordercolor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Bordercolor")) {
			Middleware.InsertCSS_Bordercolor(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleNone")) {
			Middleware.InsertCSS_BorderStyleNone(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleHidden")) {
			Middleware.InsertCSS_BorderStyleHidden(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleDotted")) {
			Middleware.InsertCSS_BorderStyleDotted(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleDashed")) {
			Middleware.InsertCSS_BorderStyleDashed(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleSolid")) {
			Middleware.InsertCSS_BorderStyleSolid(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleDouble")) {
			Middleware.InsertCSS_BorderStyleDouble(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleGroove")) {
			Middleware.InsertCSS_BorderStyleGroove(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleRidge")) {
			Middleware.InsertCSS_BorderStyleRidge(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleInset")) {
			Middleware.InsertCSS_BorderStyleInset(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_BorderStyleOutset")) {
			Middleware.InsertCSS_BorderStyleOutset(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingOneForfour")) {
			Middleware.InsertCSS_PaddingOneForfour(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingTwoForTwo")) {
			Middleware.InsertCSS_PaddingTwoForTwo(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingFourForFour")) {
			Middleware.InsertCSS_PaddingFourForFour(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingTop")) {
			Middleware.InsertCSS_PaddingTop(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingLeft")) {
			Middleware.InsertCSS_PaddingLeft(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_PaddingBottom")) {
			Middleware.InsertCSS_PaddingBottom(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Paddingright")) {
			Middleware.InsertCSS_Paddingright(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginOneForFour")) {
			Middleware.InsertCSS_MarginOneForFour(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginTwoForTwo")) {
			Middleware.InsertCSS_MarginTwoForTwo(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginFourForFour")) {
			Middleware.InsertCSS_MarginFourForFour(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginTop")) {
			Middleware.InsertCSS_MarginTop(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginLeft")) {
			Middleware.InsertCSS_MarginLeft(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_MarginBottom")) {
			Middleware.InsertCSS_MarginBottom(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Marginright")) {
			Middleware.InsertCSS_MarginRight(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Links_NoneVisited")) {
			Middleware.InsertCSS_Links_NoneVisited(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Links_Visited")) {
			Middleware.InsertCSS_Links_Visited(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Links_Activate")) {
			Middleware.InsertCSS_Links_Activate(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Links_ThreeLinks")) {
			Middleware.InsertCSS_Links_ThreeLinks(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Links_ThreeLinksTogether")) {
			Middleware.InsertCSS_Links_ThreeLinksTogether(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textalign_left")) {
			Middleware.InsertCSS_Textalign_left(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textalign_center")) {
			Middleware.InsertCSS_Textalign_center(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textalign_right")) {
			Middleware.InsertCSS_Textalign_right(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Textalign_justify")) {
			Middleware.InsertCSS_Textalign_justify(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_baseline")) {
			Middleware.InsertCSS_Valign_baseline(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_Sub")) {
			Middleware.InsertCSS_Valign_Sub(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_Super")) {
			Middleware.InsertCSS_Valign_Super(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_texttop")) {
			Middleware.InsertCSS_Valign_texttop(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_textbottom")) {
			Middleware.InsertCSS_Valign_textbottom(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_middle")) {
			Middleware.InsertCSS_Valign_middle(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_top")) {
			Middleware.InsertCSS_Valign_top(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_bottom")) {
			Middleware.InsertCSS_Valign_bottom(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_Valign_percentage")) {
			Middleware.InsertCSS_Valign_percentage(getEditor());
			return;
		}

		if (sValue.equals("InsertCSS_FieldsetLegend")) {
			Middleware.InsertCSS_FieldsetLegend(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Formrange")) {
			Middleware.InsertForm_Formrange(getEditor());
			return;
		}
		if (sValue.equals("InsertForm_FormWithAction")) {
			Middleware.InsertForm_FormWithAction(getEditor());
			return;
		}

		if (sValue.equals("InsertGridLayout")) {
			Middleware.InsertGridLayout(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_FieldsetLegend")) {
			Middleware.InsertForm_FieldsetLegend(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Label")) {
			Middleware.InsertForm_Label(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Textfeld")) {
			Middleware.InsertForm_Textfeld(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_TextfeldProperties")) {
			Middleware.InsertForm_TextfeldProperties(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_TextfeldPattern")) {
			Middleware.InsertForm_TextfeldPattern(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Textarea")) {
			Middleware.InsertForm_Textarea(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Hidden")) {
			Middleware.InsertForm_Hidden(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_CheckBox")) {
			Middleware.InsertForm_CheckBox(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_MultiCheckBox")) {
			Middleware.InsertForm_MultiCheckBox(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_RadioButton")) {
			Middleware.InsertForm_RadioButton(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_ComboBox")) {
			Middleware.InsertForm_ComboBox(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_HTML5_Number")) {
			Middleware.InsertForm_HTML5_Number(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_HTML5_Range")) {
			Middleware.InsertForm_HTML5_Range(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_HTML5_Color")) {
			Middleware.InsertForm_HTML5_Color(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_HTML5_Date")) {
			Middleware.InsertForm_HTML5_Date(getEditor());
			return;
		}

		// Events
		if (sValue.equals("InsertForm_OnClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onclick=\"myClick()\"");
			return;
		}
		if (sValue.equals("InsertForm_OnDblClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onclick=\"mydblClick()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnMouseDownClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onmousedown=\"myMouseDown()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnMouseUpClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onmouseup=\"myMouseUp()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnMouseOverClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onmouseover=\"myMouseOver()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnMouseOutClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onmouseout=\"myMouseOut()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnFocusClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onfocus=\"myOnFocus()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnBlurClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onblur=\"myOnBlur()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnKeyPressClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onkeypress=\"myOnKeyPress()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnKeyDownClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onkeydown=\"myOnKeyDown()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnKeyUpClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onkeyup=\"myOnKeyUp()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnSubmitClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onsubmit=\"myOnSubmit()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnResetClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onreset=\"myOnReset()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnSelectClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onsubmit=\"myOnSelect()\"");
			return;
		}

		if (sValue.equals("InsertForm_OnChangeClick")) {
			Middleware.InsertForm_EventsOnClick(getEditor(), "onchange=\"myOnChange()\"");
			return;
		}

		if (sValue.equals("InsertForm_Submit")) {
			Middleware.InsertForm_Submit(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Button")) {
			Middleware.InsertForm_Button(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_SubmitFormAction")) {
			Middleware.InsertForm_SubmitFormAction(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_onSubmitEvent")) {
			Middleware.InsertForm_onSubmitEvent(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_Reset")) {
			Middleware.InsertForm_Reset(getEditor());
			return;
		}

		if (sValue.equals("InsertForm_CompletSample")) {
			Middleware.InsertForm_CompletSample(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_InsertRange")) {
			Middleware.InsertJavaScript_InsertRange(getEditor());
			return;
		}

		if (sValue.equals("JavaScript_FormArray")) {
			Middleware.JavaScript_FormArray(getEditor());
			return;
		}

		if (sValue.equals("JavaScript_validation")) {
			Middleware.JavaScript_JavaScript_validation(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScriptFile")) {
			JFileChooser jFileChooser1 = new JFileChooser();
			jFileChooser1.setMultiSelectionEnabled(false);

			jFileChooser1.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
			jFileChooser1.setCurrentDirectory(new File("C:\\xampp\\htdocs"));

			jFileChooser1.addChoosableFileFilter(new MyFileFilter("js", "Java-Script-Datei (*.js)"));

			jFileChooser1.setPreferredSize(new Dimension(1000, 600));
			jFileChooser1.setDialogTitle("EineJavascript-Datei statisch einbinden");
			// Okay gedrückt ?
			if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
				String filename = jFileChooser1.getSelectedFile().getPath();
				Middleware.InsertJavaScriptFile(getEditor(), Basis.getFileNameExt(filename));
			}
			return;
		}

		if (sValue.equals("InsertJavaScript_Function")) {
			Middleware.InsertJavaScript_Function(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Consolelog")) {
			Middleware.InsertJavaScript_Consolelog(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onload")) {
			Middleware.InsertJavaScript_Event_onload(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onUnload")) {
			Middleware.InsertJavaScript_Event_onUnload(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onClick")) {
			Middleware.InsertJavaScript_Event_onClick(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_onDblclick")) {
			Middleware.InsertJavaScript_onDblclick(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onMouseDown")) {
			Middleware.InsertJavaScript_Event_onMouseDown(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onMouseUp")) {
			Middleware.InsertJavaScript_Event_onMouseUp(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onMouseOver")) {
			Middleware.InsertJavaScript_Event_onMouseOver(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onMouseMove")) {
			Middleware.InsertJavaScript_Event_onMouseMove(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onMouseOut")) {
			Middleware.InsertJavaScript_Event_onMouseOut(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onFocus")) {
			Middleware.InsertJavaScript_Event_onFocus(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onBlur")) {
			Middleware.InsertJavaScript_Event_onBlur(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onKeypress")) {
			Middleware.InsertJavaScript_Event_onKeypress(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onKeydown")) {
			Middleware.InsertJavaScript_Event_onKeydown(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onKeypup")) {
			Middleware.InsertJavaScript_Event_onKeypup(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onSubmit")) {
			Middleware.InsertJavaScript_Event_onSubmit(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onReset")) {
			Middleware.InsertJavaScript_Event_onReset(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onSelect")) {
			Middleware.InsertJavaScript_Event_onSelect(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Event_onChange")) {
			Middleware.InsertJavaScript_Event_onChange(getEditor());
			return;
		}

		// AJAX

		if (sValue.equals("InsertJavaScript_getElementById")) {
			Middleware.InsertJavaScript_getElementById(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_getElementByClassName")) {
			Middleware.InsertJavaScript_getElementByClassName(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_getElementByName")) {
			Middleware.InsertJavaScript_getElementByName(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_getElementByTagName")) {
			Middleware.InsertJavaScript_getElementByTagName(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_innerHTML")) {
			Middleware.InsertJavaScript_innerHTML(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_JsonForEachLoop1")) {
			Middleware.InsertJavaScript_JsonForEachLoop1(getEditor());
			return;
		}
		if (sValue.equals("InsertJavaScript_JsonForEachLoop2")) {
			Middleware.InsertJavaScript_JsonForEachLoop2(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_AjaxStruktur")) {
			String xmlhttp = Basis.getInput("Name des XMLHttpRequest", "xmlhttp-Name", "xmlhttp1");
			if (xmlhttp != null && xmlhttp.length() > 0) {
				Middleware.InsertJavaScript_AjaxStruktur(getEditor(), xmlhttp);
			}
			return;
		}

		if (sValue.equals("mnJavaScript_Access_form0")) {
			Middleware.InsertText(getEditor(), "\tlet f=document.forms[0];");
			return;
		}
		if (sValue.equals("mnJavaScript_Access_formName")) {
			Middleware.InsertText(getEditor(), "let f=form.theName1;" + Basis.getlineSeparator());
			return;
		}
		if (sValue.equals("mnJavaScript_Access_textValue")) {
			Middleware.InsertText(getEditor(), "\tlet s = form.myTextbox.value;");
			return;
		}
		if (sValue.equals("mnJavaScript_Access_checkbox")) {
			Middleware.InsertText(getEditor(), "\tif (form.myChk.checked ) {" + Basis.getlineSeparator() + "\t}");
			return;
		}
		if (sValue.equals("mnJavaScript_Access_multicheckbox")) {
			Middleware.mnJavaScript_Access_multicheckbox(getEditor());
			return;
		}
		if (sValue.equals("mnJavaScript_Access_radiobutton")) {
			Middleware.mnJavaScript_AccessRadiobutton(getEditor());
			return;
		}
		if (sValue.equals("mnJavaScript_Access_comboboxSingle")) {
			Middleware.mnJavaScript_Access_comboboxSingle(getEditor());
			return;
		}
		if (sValue.equals("mnJavaScript_Access_comboboxMultiple")) {
			Middleware.mnJavaScript_Access_comboboxMultiple(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_If")) {
			Middleware.InsertJavaScript_If(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_If_Else")) {
			Middleware.InsertJavaScript_If_Else(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Dowhile")) {
			Middleware.InsertJavaScript_Dowhile(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_While")) {
			Middleware.InsertJavaScript_While(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_For_i")) {
			Middleware.InsertJavaScript_For_i(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Foreach")) {
			Middleware.InsertJavaScript_Foreach(getEditor());
			return;
		}
		if (sValue.equals("InsertJavaScript_ForeachOf")) {
			Middleware.InsertJavaScript_ForeachOf(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Switch")) {
			Middleware.InsertJavaScript_Switch(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_ParseInt")) {
			Middleware.InsertJavaScript_ParseInt(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_ParseFloat")) {
			Middleware.InsertJavaScript_ParseFloat(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_isNaN")) {
			Middleware.InsertJavaScript_isNaN(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_komma2Point")) {
			Middleware.InsertJavaScript_komma2Point(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_toFixed")) {
			Middleware.InsertJavaScript_toFixed(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_split")) {
			Middleware.InsertJavaScript_split(getEditor());
			return;
		}

		if (sValue.equals("InsertJavaScript_Popupwindow")) {
			Middleware.InsertJavaScript_Popupwindow(getEditor());
			return;
		}

		if (sValue.equals("mnJavaScript_Arrays_createArray")) {
			// let feld = []; // new Array(MAX); MAX elements
			Middleware.InsertText(getEditor(), "\t\tlet feld = [];  // new Array(MAX);  MAX elements");
			return;
		}
		if (sValue.equals("mnJavaScript_Arrays_createMultidimArray")) {
			Middleware.mnJavaScript_Arrays_createMultidimArray(getEditor());
			return;
		}
		if (sValue.equals("mnJavaScript_lengthArray")) {
			Middleware.InsertText(getEditor(), ".length");
			return;
		}
		if (sValue.equals("mnJavaScript_Arrays_pushArray")) {
			Middleware.InsertText(getEditor(), "feld.push( new MyClass() );");
			return;
		}
		if (sValue.equals("mnJavaScript_Arrays_sliceArra")) {
			Middleware.InsertText(getEditor(), "feld.slice( i, 1 );");
			return;
		}

		if (sValue.equals("mnJavaScript_Class_createClass")) {
			Middleware.mnJavaScript_Class_createClass(getEditor());
			return;
		}

		if (sValue.equals("mnJavaScript_Class_StaticAttribut")) {
			Middleware.InsertText(getEditor(), "MyClass.color='blue';");
			return;
		}

		if (sValue.equals("InsertJavaScript_Regex")) {
			Middleware.InsertJavaScript_Regex(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_Range")) {
			Middleware.InsertPHP_Range(getEditor());
			return;
		}
		
		if (sValue.equals("InsertPHP_Funktion")) {
			Middleware.InsertPHP_Funktion(getEditor());
			return;
		}

		if (sValue.equals("PHP_InsertPHP_isset")) {
			Middleware.PHP_InsertPHP_isset(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_InsertPHP_issetSelectMultiple")) {
			Middleware.mnPHP_InsertPHP_issetSelectMultiple(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_Isnumeric")) {
			Middleware.InsertPHP_Isnumeric(getEditor());
			return;
		}
		if (sValue.equals("InsertPHP_IsInt")) {
			Middleware.InsertPHP_IsInt(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_IsFloat")) {
			Middleware.InsertPHP_IsFloat(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_IntVal")) {
			Middleware.InsertPHP_IntVal(getEditor());
			return;
		}
		if (sValue.equals("InsertPHP_FloatVal")) {
			Middleware.InsertPHP_FloatVal(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_InsertClassResult")) {
			Middleware.PHP_InsertClassResult(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_InsertClassNumber")) {
			Middleware.PHP_InsertClassNumber(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_Attribute")) {
			String attrib = Basis.getInput("New attrib", "Name of the new attrib (without $)");
			if (attrib != null && attrib.length() > 0) {
				Middleware.PHP_Attribute(getEditor(), attrib);
			}
			return;
		}

		if (sValue.equals("mnPHP_InsertPHPFile")) {
			JFileChooser jFileChooser1 = new JFileChooser();
			jFileChooser1.setMultiSelectionEnabled(false);

			jFileChooser1.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
			jFileChooser1.setCurrentDirectory(new File("C:\\xampp\\htdocs"));

			jFileChooser1.addChoosableFileFilter(new MyFileFilter("js", "Java-Script-Datei (*.js)"));

			jFileChooser1.setPreferredSize(new Dimension(1000, 600));
			jFileChooser1.setDialogTitle("EineJavascript-Datei statisch einbinden");
			// Okay gedrückt ?
			if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
				String filename = jFileChooser1.getSelectedFile().getPath();
				Middleware.InsertPHPFile(getEditor(), Basis.getFileNameExt(filename));
			}
			return;
		}
		if (sValue.equals("mnPHP_JSon_encodepur")) {
			Middleware.PHP_JSon_encodepur(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_JSon")) {
			Middleware.PHP_JSon(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_json_encode")) {
			Middleware.PHP_json_encode(getEditor());
			return;
		}

		// ----------------------------------------------------------------
		if (sValue.equals("mnPHP_If")) {
			Middleware.PHP_If(getEditor());
			return;
		}
	
	if (sValue.equals("mnPHP_If_Else")) {
		Middleware.PHP_If_Else(getEditor());
		return;
	}
	
	if (sValue.equals("mnPHP_If_ok_Else")) {
		Middleware.PHP_If_ok_Else(getEditor());
		return;
	}
		
		
		if (sValue.equals("mnPHP_Dowhile")) {
			Middleware.PHP_Dowhile(getEditor());
			return;
		}
		

		if (sValue.equals("mnPHP_While")) {
			Middleware.PHP_While(getEditor());
			return;
		}
		
		if (sValue.equals("mnPHP_For_i")) {
			Middleware.PHP_For_i(getEditor());
			return;
		}				
		
		if (sValue.equals("mnPHP_Foreach")) {
			Middleware.PHP_Foreach(getEditor());
			return;
		}		
		
		
		if (sValue.equals("mnPHP_Switch")) {
			Middleware.PHP_Switch(getEditor());
			return;
		}
		
		
		// -----------------------------------------------------
		if (sValue.equals("mnPHP_Arrays_createArray")) {
			Middleware.PHP_Arrays_createArray(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_Arrays_createArrayWidthItems")) {
			Middleware.PHP_Arrays_createArrayWithItems(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_Arrays_createMultidimArray")) {
			Middleware.PHP_Arrays_createMultidimArray(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_Arrays_pushArray")) {
			Middleware.PHP_Arrays_pushArray(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_Arrays_arrayLength")) {
			Middleware.PHP_Arrays_arrayLength(getEditor());
			return;
		}
		if (sValue.equals("mnPHP_Arrays_foreach")) {
			Middleware.PHP_Arrays_foreach(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_regex")) {
			Middleware.PHP_regex(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_echoText")) {
			Middleware.InsertPHP_echoText(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_echoStringAndVariable")) {
			Middleware.InsertPHP_echoStringAndVariable(getEditor());
			return;
		}

		if (sValue.equals("InsertPHP_echoStringAndVariable_withPoint")) {
			Middleware.InsertPHP_echoStringAndVariable_withPoint(getEditor());
			return;
		}

		if (sValue.equals("mnPHP_weiterleitung")) {
			Middleware.InsertPHP_weiterleitung(getEditor());
			return;
		}

		
		Basis.ErrorBox(
				"Menü " + Caption + " konnte nicht als Aktion gefunden werden\n" + "Bitte EMail an Herrn Wilhelm ",
				"Fehler");

	} // StartCommand

	private void setMenues() {
		this.setJMenuBar(menuBar1);

		JMenu MainHTML = new JMenu("Basic-HTML");
		menuBar1.add(MainHTML);

		JMenu MnInsertHTMLBasic = new JMenu("Basics");
		MainHTML.add(MnInsertHTMLBasic);
		insertMenue(MnInsertHTMLBasic, "with DocType for the new CSS-Pages, XHTML (Version 1.01)",
				"InsertHTML_Basic_XHTML_strict11");
		insertMenue(MnInsertHTMLBasic, "with DocType for the new CSS-Pages, XHTML (HTML Version 4.01)",
				"InsertHTML_Basic_XHTML");
		insertMenue(MnInsertHTMLBasic, "with DocType for old pages", "InsertHTML_HTML4");
		insertMenue(MnInsertHTMLBasic, "pures HTML, without DocType", "InsertHTML_Basic_Pur");

		// -----------
		insertMenue(MainHTML, "header", "InsertHTML_Header");
		insertMenue(MainHTML, "Paragraphs", "InsertHTML_Paragraph");
		insertMenue(MainHTML, "Header (h1..h6)", "InsertHTML_Header3");

		JMenu MnHTML_ListeSub = new JMenu("Liste");
		MainHTML.add(MnHTML_ListeSub);
		insertMenue(MnHTML_ListeSub, "Unordered List", "InsertHTML_UL");
		insertMenue(MnHTML_ListeSub, "Ordered List", "InsertHTML_OL");

		// -----------
		JMenu MnHTML_Tables = new JMenu("Table");
		MainHTML.add(MnHTML_Tables);

		insertMenue(MnHTML_Tables, "Insert table...", "InsertHTML_Table");
		insertMenue(MnHTML_Tables, "Insert table row", "InsertHTML_TR");

		insertMenue(MainHTML, "Horizontal line", "InsertHTML_HR");
		insertMenue(MainHTML, "Color (Hex)", "InsertCSS_FontColor");
		insertMenue(MainHTML, "Color constant", "InsertCSS_ColorConstant_Click");
		insertMenue(MainHTML, "E-Mail Link", "InsertHTML_EMailLink");
		insertMenue(MainHTML, "Link", "InsertHTML_Link");
		insertMenue(MainHTML, "Anchor", "InsertHTML_Anchor");
		insertMenue(MainHTML, "Comment", "InsertHTML_Comment");
		insertMenue(MainHTML, "Picture", "MnInsertGrafik_Click()");

		// -----------

		JMenu MainFonts = new JMenu("Font");
		menuBar1.add(MainFonts);

		insertMenue(MainFonts, "Bold", "InsertHTML_Font_Bold");
		insertMenue(MainFonts, "Italic", "InsertHTML_Font_Italic");
		insertMenue(MainFonts, "Underline (veraltet)", "InsertHTML_Font_Underline");
		insertMenue(MainFonts, "Drive through (veraltet)", "InsertHTML_Font_LineThrough");
		insertMenue(MainFonts, "Super", "InsertHTML_Font_Sup");
		insertMenue(MainFonts, "Sub", "InsertHTML_Font_Sub");

		// ----
		JMenu MnFont_SpezialChars = new JMenu("Special chars");
		MainFonts.add(MnFont_SpezialChars);
		insertMenue(MnFont_SpezialChars, "Spaces (&#x0020;)", "InsertHTML_Font_Char_Space");
		insertMenue(MnFont_SpezialChars, "Tab (&#x0009;)", "InsertHTML_Font_Char_Tab");
		insertMenue(MnFont_SpezialChars, "Carriage Return (&#x000D;)", "InsertHTML_Font_Char_CR");
		insertMenue(MnFont_SpezialChars, "Line Feed (&#x000A;)", "InsertHTML_Font_Char_LF");
		insertMenue(MnFont_SpezialChars, "Fixed Space", "InsertHTML_Font_Char_Blank");
		insertMenue(MnFont_SpezialChars, "Trennzeichen", "InsertHTML_Font_Char_Dash");
		insertMenue(MnFont_SpezialChars, "Copyright (c)", "InsertHTML_Font_Char_Copyright");
		insertMenue(MnFont_SpezialChars, "Copyright (R)", "InsertHTML_Font_Char_Copyright_R");
		insertMenue(MnFont_SpezialChars, "Trademark TM", "InsertHTML_Font_Char_Trademark");
		insertMenue(MnFont_SpezialChars, "<", "InsertHTML_Font_Char_LT");
		insertMenue(MnFont_SpezialChars, ">", "InsertHTML_Font_Char_GT");
		insertMenue(MnFont_SpezialChars, "<<", "InsertHTML_Font_Char_LTLT");
		insertMenue(MnFont_SpezialChars, ">>", "InsertHTML_Font_Char_GTGT");

		// ----------------
		JMenu MainCSS = new JMenu("CSS");
		menuBar1.add(MainCSS);

		insertMenue(MainCSS, "Insert externe Referenz", "InsertHTML_CSSReferenzExtern");
		insertMenue(MainCSS, "Insert lokale Styles", "InsertHTML_CSSReferenzLocal");
		insertMenue(MainCSS, "Css basics", "InsertCSS_Body");
		insertMenue(MainCSS, "empty CSS-Block", "InsertCSS_xx");

		JMenu MnCSSBsp = new JMenu("Selectors");
		MainCSS.add(MnCSSBsp);
		insertMenue(MnCSSBsp, "h2", "InsertCSS_H2");
		insertMenue(MnCSSBsp, "ol", "InsertCSS_OL");
		insertMenue(MnCSSBsp, "ul", "InsertCSS_UL");
		insertMenue(MnCSSBsp, "th", "InsertCSS_TH");
		insertMenue(MnCSSBsp, "td", "InsertCSS_TH");

		insertMenue(MainCSS, "Scrolling", "InsertHTML_Scrolling");

		JMenu MnCSS_Image = new JMenu("Picture / body");
		MainCSS.add(MnCSS_Image);
		insertMenue(MnCSS_Image, "Body: background-image", "InsertCSS_background_image");
		insertMenue(MnCSS_Image, "Body: background-repeat", "InsertCSS_Body_backgroundrepeat");
		insertMenue(MnCSS_Image, "Body: background-attachment", "InsertCSS_Bodybackgroundattachment");
		insertMenue(MnCSS_Image, "Body: background-position", "InsertCSS_Body_backgroundposition");

		// ---------------------------------
		JMenu MnCSS_Colors = new JMenu("Colors");
		MainCSS.add(MnCSS_Colors);
		insertMenue(MnCSS_Colors, "Color constant", "InsertCSS_ColorConstant");
		insertMenue(MnCSS_Colors, "Color (Hex)", "InsertCSS_FontColor");
		insertMenue(MnCSS_Colors, "Background color", "InsertCSS_BackgroundColor");

		// -------------
		JMenu MnCSS_Fonts = new JMenu("Font");
		MainCSS.add(MnCSS_Fonts);
		insertMenue(MnCSS_Fonts, "Font Size=1,2em", "InsertCSS_FontSize_12em");
		insertMenue(MnCSS_Fonts, "Font color", "InsertCSS_FontColor");

		JMenu MnInsertCSS_Fonttyp = new JMenu("Font name");
		MnCSS_Fonts.add(MnInsertCSS_Fonttyp);
		insertMenue(MnInsertCSS_Fonttyp, "Verdana, Arial, Helvetica, Swiss", "InsertCSS_Fonttyp_Verdana");
		insertMenue(MnInsertCSS_Fonttyp, "Courier New", "InsertCSS_Fonttyp_CourierNew");
		insertMenue(MnInsertCSS_Fonttyp, "Monospace", "InsertCSS_Fonttyp_Monospace");

		JMenu MnInsertCSS_relative_Font = new JMenu("rel. font size");
		MnCSS_Fonts.add(MnInsertCSS_relative_Font);

		insertMenue(MnInsertCSS_relative_Font, "Smallest font", "InsertCSS_SmallestFont");
		insertMenue(MnInsertCSS_relative_Font, "Smaller font", "InsertCSS_SmallerFont");
		insertMenue(MnInsertCSS_relative_Font, "Bigger font", "InsertCSS_BiggerFont");
		insertMenue(MnInsertCSS_relative_Font, "Biggest font", "InsertCSS_BigFont");
		MnInsertCSS_relative_Font.addSeparator();
		insertMenue(MnInsertCSS_relative_Font, "Font with em", "InsertCSS_FontSize_15Em");
		insertMenue(MnInsertCSS_relative_Font, "Font with Percentage", "InsertCSS_Bigger_Percentage");

		insertMenue(MnCSS_Fonts, "Word-Spacing", "InsertCSS_WordSpacing");
		insertMenue(MnCSS_Fonts, "Letter-Spacing", "InsertCSS_LetterSpacing");

		JMenu MnInsertCSS_Textdecoration = new JMenu("text-decoration");
		MnCSS_Fonts.add(MnInsertCSS_Textdecoration);
		insertMenue(MnInsertCSS_Textdecoration, "none", "InsertCSS_Textdecoration_None");
		insertMenue(MnInsertCSS_Textdecoration, "underline", "InsertCSS_Textdecoration_Underline");
		insertMenue(MnInsertCSS_Textdecoration, "overline", "InsertCSS_Textdecoration_Overline");
		insertMenue(MnInsertCSS_Textdecoration, "linethrough", "InsertCSS_Textdecoration_linethrough");
		insertMenue(MnInsertCSS_Textdecoration, "blinkend", "InsertCSS_Textdecoration_blink");
		insertMenue(MnInsertCSS_Textdecoration, "italic/kursiv", "InsertCSS_Textdecoration_Italic");

		// -----
		JMenu MnInsertCSS_Texttransform = new JMenu("text-transform");
		MnCSS_Fonts.add(MnInsertCSS_Texttransform);

		insertMenue(MnInsertCSS_Texttransform, "none", "InsertCSS_TextTransform_none");
		insertMenue(MnInsertCSS_Texttransform, "uppercase", "InsertCSS_TextTransform_uppercase");
		insertMenue(MnInsertCSS_Texttransform, "lowercase", "InsertCSS_TextTransform_lowercase");
		insertMenue(MnInsertCSS_Texttransform, "capitalize", "InsertCSS_TextTransform_capitalize");
		insertMenue(MnInsertCSS_Texttransform, "nnn", "");

		insertMenue(MnCSS_Fonts, "text-indent", "InsertCSS_Text_Indent");

		JMenu MnCSS_Lists = new JMenu("Lists");
		MainCSS.add(MnCSS_Lists);

		JMenu MnCSS_Lists_UL = new JMenu("ul");
		MnCSS_Lists.add(MnCSS_Lists_UL);

		insertMenue(MnCSS_Lists_UL, "none", "InsertCSS_UL_listeNone");
		insertMenue(MnCSS_Lists_UL, "circle", "InsertCSS_UL_Listecircle");
		insertMenue(MnCSS_Lists_UL, "square", "InsertCSS_UL_Listesquare");
		insertMenue(MnCSS_Lists_UL, "disc", "InsertCSS_UL_Listedisc");

		JMenu MnCSS_Lists_OL = new JMenu("ol");
		MnCSS_Lists.add(MnCSS_Lists_OL);
		insertMenue(MnCSS_Lists_OL, "none", "InsertCSS_OL_ListeNone");
		insertMenue(MnCSS_Lists_OL, "decimal", "InsertCSS_OL_Listedecimal");
		insertMenue(MnCSS_Lists_OL, "decimal-leading-zero", "InsertCSS_OL_Listedecimalleadingzero");
		insertMenue(MnCSS_Lists_OL, "lower-roman", "InsertCSS_OL_Listelowerroman");
		insertMenue(MnCSS_Lists_OL, "upper-roman", "InsertCSS_OL_Listeupperroman");
		insertMenue(MnCSS_Lists_OL, "lower-greek", "InsertCSS_OL_Listelowergreek");
		insertMenue(MnCSS_Lists_OL, "upper-greek", "InsertCSS_OL_Listeuppergreek");
		insertMenue(MnCSS_Lists_OL, "lower-latin", "InsertCSS_OL_Listelowerlatin");
		insertMenue(MnCSS_Lists_OL, "upper-latin", "InsertCSS_OL_ListeUpperlatin");

		JMenu MnCSS_Lists_Liststyleposition = new JMenu("list-style-position");
		MnCSS_Lists.add(MnCSS_Lists_Liststyleposition);

		insertMenue(MnCSS_Lists_Liststyleposition, "inside", "InsertCSS_ListStylePosition_inside");
		insertMenue(MnCSS_Lists_Liststyleposition, "outside", "InsertCSS_ListStylePosition_outside");
		// ---

		JMenu MnCSS_Tables = new JMenu("Tables");
		MainCSS.add(MnCSS_Tables);
		insertMenue(MnCSS_Tables, "th", "InsertCSS_TH");
		insertMenue(MnCSS_Tables, "td", "InsertCSS_TD");
		insertMenue(MnCSS_Tables, "Tables with borders / margins", "InsertCSS_TableBorderTDTHTable");

		JMenu MnCSS_Borders = new JMenu("Margins");
		MainCSS.add(MnCSS_Borders);

		insertMenue(MnCSS_Borders, "Border color", "InsertCSS_Bordercolor");

		insertMenue(MnCSS_Borders, "Border-Width", "InsertCSS_BorderWidth");

		JMenu MnInsertCSS_BorderStyles = new JMenu("Border-Styles");
		MnCSS_Borders.add(MnInsertCSS_BorderStyles);
		insertMenue(MnInsertCSS_BorderStyles, "none", "InsertCSS_BorderStyleNone");
		insertMenue(MnInsertCSS_BorderStyles, "hidden", "InsertCSS_BorderStyleHidden");
		insertMenue(MnInsertCSS_BorderStyles, "dotted", "InsertCSS_BorderStyleDotted");
		insertMenue(MnInsertCSS_BorderStyles, "dashed", "InsertCSS_BorderStyleDashed");
		insertMenue(MnInsertCSS_BorderStyles, "solid", "InsertCSS_BorderStyleSolid");
		insertMenue(MnInsertCSS_BorderStyles, "double", "InsertCSS_BorderStyleDouble");
		insertMenue(MnInsertCSS_BorderStyles, "groove", "InsertCSS_BorderStyleGroove");
		insertMenue(MnInsertCSS_BorderStyles, "ridge", "InsertCSS_BorderStyleRidge");
		insertMenue(MnInsertCSS_BorderStyles, "inset", "InsertCSS_BorderStyleInset");
		insertMenue(MnInsertCSS_BorderStyles, "outset", "InsertCSS_BorderStyleOutset");

		// ---------
		JMenu MnInsertCSS_Padding = new JMenu("Padding");
		MnCSS_Borders.add(MnInsertCSS_Padding);

		insertMenue(MnInsertCSS_Padding, "One value for all four values", "InsertCSS_PaddingOneForfour");
		insertMenue(MnInsertCSS_Padding, "Two values: top/bottom  und left/right", "InsertCSS_PaddingTwoForTwo");
		insertMenue(MnInsertCSS_Padding, "Four values", "InsertCSS_PaddingFourForFour");
		MnInsertCSS_Padding.addSeparator();
		insertMenue(MnInsertCSS_Padding, "Padding-top", "InsertCSS_PaddingTop");
		insertMenue(MnInsertCSS_Padding, "Padding-left", "InsertCSS_PaddingLeft");
		insertMenue(MnInsertCSS_Padding, "Padding-bottom", "InsertCSS_PaddingBottom");
		insertMenue(MnInsertCSS_Padding, "Padding-right", "InsertCSS_Paddingright");

		JMenu MnInsertCSS_Margin = new JMenu("Margin");
		MnCSS_Borders.add(MnInsertCSS_Margin);
		insertMenue(MnInsertCSS_Margin, "One value for all four values", "InsertCSS_MarginOneForFour");
		insertMenue(MnInsertCSS_Margin, "Two values: top/bottom  und left/right", "InsertCSS_MarginTwoForTwo");
		insertMenue(MnInsertCSS_Margin, "Four values", "InsertCSS_MarginFourForFour");
		MnInsertCSS_Margin.addSeparator();
		insertMenue(MnInsertCSS_Margin, "Margin-top", "InsertCSS_MarginTop");
		insertMenue(MnInsertCSS_Margin, "Margin-left", "InsertCSS_MarginLeft");
		insertMenue(MnInsertCSS_Margin, "Margin-bottom", "InsertCSS_MarginBottom");
		insertMenue(MnInsertCSS_Margin, "Margin-right", "InsertCSS_MarginRight");

		JMenu MnCSS_Links = new JMenu("Links");
		MainCSS.add(MnCSS_Links);

		insertMenue(MnCSS_Links, "None Visited", "InsertCSS_Links_NoneVisited");
		insertMenue(MnCSS_Links, "Visited", "InsertCSS_Links_Visited");
		insertMenue(MnCSS_Links, "Activate", "InsertCSS_Links_Activate");
		insertMenue(MnCSS_Links, "Alle drei Links (untereinander)", "InsertCSS_Links_ThreeLinks");
		insertMenue(MnCSS_Links, "Alle drei Links (zusammen)", "InsertCSS_Links_ThreeLinksTogether");

		JMenu MnCSS_HAlign = new JMenu("Horizontal Alignment");
		MainCSS.add(MnCSS_HAlign);
		insertMenue(MnCSS_HAlign, "Links ausgerichtet", "InsertCSS_Textalign_left");
		insertMenue(MnCSS_HAlign, "Zentriert ausgerichtet", "InsertCSS_Textalign_center");
		insertMenue(MnCSS_HAlign, "Rechts ausgerichtet", "InsertCSS_Textalign_right");
		insertMenue(MnCSS_HAlign, "Blocksatz", "InsertCSS_Textalign_justify");

		JMenu MnCSS_VAlign = new JMenu("Vertical Alignment");
		MainCSS.add(MnCSS_VAlign);
		insertMenue(MnCSS_VAlign, "baseline", "InsertCSS_Valign_baseline");
		insertMenue(MnCSS_VAlign, "sub", "InsertCSS_Valign_Sub");
		insertMenue(MnCSS_VAlign, "sup", "InsertCSS_Valign_Super");
		insertMenue(MnCSS_VAlign, "text-top", "InsertCSS_Valign_texttop");
		insertMenue(MnCSS_VAlign, "text-bottom", "InsertCSS_Valign_textbottom");
		insertMenue(MnCSS_VAlign, "middle", "InsertCSS_Valign_middle");
		insertMenue(MnCSS_VAlign, "top", "InsertCSS_Valign_top");
		insertMenue(MnCSS_VAlign, "bottom", "InsertCSS_Valign_bottom");
		insertMenue(MnCSS_VAlign, "percentage", "InsertCSS_Valign_percentage");

		insertMenue(MainCSS, "Fieldset/Legend", "InsertCSS_FieldsetLegend");

		// FORMS
		JMenu MainForms = new JMenu("Forms");
		menuBar1.add(MainForms);

		insertMenue(MainForms, "Insert form sector", "InsertForm_Formrange");
		insertMenue(MainForms, "Insert form sector mit action-script", "InsertForm_FormWithAction");
		MainForms.addSeparator();
		JMenu mnLayout = new JMenu("Layout");
		MainForms.add(mnLayout);
		insertMenue(mnLayout, "Grid layout (label/input text)", "InsertGridLayout");

		MainForms.addSeparator();
		insertMenue(MainForms, "Fieldset / Legend", "InsertForm_FieldsetLegend");
		insertMenue(MainForms, "Label", "InsertForm_Label");
		insertMenue(MainForms, "Simple Textfeld", "InsertForm_Textfeld");
		insertMenue(MainForms, "Textfeld mit properties", "InsertForm_TextfeldProperties");
		insertMenue(MainForms, "Textfeld pattern", "InsertForm_TextfeldPattern");
		insertMenue(MainForms, "Textarea (mehrzeiligen Editor)", "InsertForm_Textarea");
		insertMenue(MainForms, "Hidden", "InsertForm_Hidden");
		insertMenue(MainForms, "CheckBox", "InsertForm_CheckBox");
		insertMenue(MainForms, "Multi-CheckBox", "InsertForm_MultiCheckBox");
		insertMenue(MainForms, "RadioButton", "InsertForm_RadioButton");
		insertMenue(MainForms, "ComboBox", "InsertForm_ComboBox");
		insertMenue(MainForms, "Number", "InsertForm_HTML5_Number");

		MainForms.addSeparator();
		// Events

		JMenu mnEvents = new JMenu("Events");
		MainForms.add(mnEvents);
		insertMenue(mnEvents, "OnClick", "InsertForm_OnClick");
		insertMenue(mnEvents, "OnDblClick", "InsertForm_OnDblClick");
		insertMenue(mnEvents, "OnMouseDown", "InsertForm_OnMouseDownClick");
		insertMenue(mnEvents, "OnMouseUp", "InsertForm_OnMouseUpClick");
		insertMenue(mnEvents, "OnMouseOver", "InsertForm_OnMouseOverClick");
		insertMenue(mnEvents, "OnMouseOut", "InsertForm_OnMouseOutClick");

		insertMenue(mnEvents, "OnFocus", "InsertForm_OnFocusClick");
		insertMenue(mnEvents, "OnBlur (outFocus)", "InsertForm_OnBlurClick");

		insertMenue(mnEvents, "OnKeyPress", "InsertForm_OnKeyPressClick");
		insertMenue(mnEvents, "OnKeyDown", "InsertForm_OnKeyDownClick");
		insertMenue(mnEvents, "OnKeyUp", "InsertForm_OnKeyUpClick");

		insertMenue(mnEvents, "OnSubmit", "InsertForm_OnSubmitClick");
		insertMenue(mnEvents, "OnReset", "InsertForm_OnResetClick");
		insertMenue(mnEvents, "OnSelect", "InsertForm_OnSelectClick");
		insertMenue(mnEvents, "OnChange", "InsertForm_OnChangeClick");

		MainForms.addSeparator();
		insertMenue(MainForms, "Submit-Schalter", "InsertForm_Submit");
		insertMenue(MainForms, "Button-Schalter", "InsertForm_Button");

		insertMenue(MainForms, "Reset-Schalter", "InsertForm_Reset");
		insertMenue(MainForms, "Submit-Schalter mit onSubmit-Event", "InsertForm_onSubmitEvent");

		insertMenue(MainForms, "Submit-Schalter (FormAction)", "InsertForm_SubmitFormAction");

		MainForms.addSeparator();

		insertMenue(MainForms, "Complete sample", "InsertForm_CompletSample");

		JMenu MnInsertForm_HTML5 = new JMenu("HTML5");
		insertMenue(MnInsertForm_HTML5, "number", "InsertForm_HTML5_Number");
		insertMenue(MnInsertForm_HTML5, "range", "InsertForm_HTML5_Range");
		insertMenue(MnInsertForm_HTML5, "color", "InsertForm_HTML5_Color");
		insertMenue(MnInsertForm_HTML5, "date", "InsertForm_HTML5_Date");

		// JavaScript
		JMenu MainJavaScript = new JMenu("Java-Script");
		menuBar1.add(MainJavaScript);

		insertMenue(MainJavaScript, "Insert Java-Script-Text", "InsertJavaScript_InsertRange");
		insertMenue(MainJavaScript, "Include Java-Script-File (static)", "InsertJavaScriptFile");
		MainJavaScript.addSeparator();
		insertMenue(MainJavaScript, "Insert Form Array", "JavaScript_FormArray");
		insertMenue(MainJavaScript, "Insert Validation Script", "JavaScript_validation");
		MainJavaScript.addSeparator();
		insertMenue(MainJavaScript, "function", "InsertJavaScript_Function");
		insertMenue(MainJavaScript, "console.log", "InsertJavaScript_Consolelog");

		JMenu MnJavaScript_Event = new JMenu("Events");
		MainJavaScript.add(MnJavaScript_Event);

		insertMenue(MnJavaScript_Event, "onload", "InsertJavaScript_Event_onload");
		insertMenue(MnJavaScript_Event, "onUnload", "InsertJavaScript_Event_onUnload");
		insertMenue(MnJavaScript_Event, "onClick", "InsertJavaScript_Event_onClick");
		insertMenue(MnJavaScript_Event, "onDblclick", "InsertJavaScript_onDblclick");
		insertMenue(MnJavaScript_Event, "onMouseDown", "InsertJavaScript_Event_onMouseDown");
		insertMenue(MnJavaScript_Event, "onMouseUp", "InsertJavaScript_Event_onMouseUp");
		insertMenue(MnJavaScript_Event, "onMouseOver", "InsertJavaScript_Event_onMouseOver");
		insertMenue(MnJavaScript_Event, "onMouseMove", "InsertJavaScript_Event_onMouseMove");
		insertMenue(MnJavaScript_Event, "onMouseOut", "InsertJavaScript_Event_onMouseOut");
		insertMenue(MnJavaScript_Event, "onFocus", "InsertJavaScript_Event_onFocus");
		insertMenue(MnJavaScript_Event, "onBlur (outFocus)", "InsertJavaScript_Event_onBlur");
		insertMenue(MnJavaScript_Event, "onKeypress", "InsertJavaScript_Event_onKeypress");
		insertMenue(MnJavaScript_Event, "onKeydown", "InsertJavaScript_Event_onKeydown");
		insertMenue(MnJavaScript_Event, "onKeypup", "InsertJavaScript_Event_onKeypup");
		insertMenue(MnJavaScript_Event, "onSubmit", "InsertJavaScript_Event_onSubmit");
		insertMenue(MnJavaScript_Event, "onReset", "InsertJavaScript_Event_onReset");
		insertMenue(MnJavaScript_Event, "onSelect", "InsertJavaScript_Event_onSelect");
		insertMenue(MnJavaScript_Event, "onChange", "InsertJavaScript_Event_onChange");

		JMenu mnJavaScript_Ajax = new JMenu("Ajax");
		MainJavaScript.add(mnJavaScript_Ajax);

		insertMenue(mnJavaScript_Ajax, "getElementById", "InsertJavaScript_getElementById");
		insertMenue(mnJavaScript_Ajax, "getElementByClassName", "InsertJavaScript_getElementByClassName");
		insertMenue(mnJavaScript_Ajax, "getElementByName", "InsertJavaScript_getElementByName");
		insertMenue(mnJavaScript_Ajax, "getElementByTagName", "InsertJavaScript_getElementByTagName");
		insertMenue(mnJavaScript_Ajax, "innerHTML", "InsertJavaScript_innerHTML");
		insertMenue(mnJavaScript_Ajax, "Json for each loop", "InsertJavaScript_JsonForEachLoop");
		insertMenue(mnJavaScript_Ajax, "Ajax Struktur", "InsertJavaScript_AjaxStruktur");

		JMenu mnJavaScript_Access2FormsElements = new JMenu("Access to form-elements in java-script");
		MainJavaScript.add(mnJavaScript_Access2FormsElements);
		insertMenue(mnJavaScript_Access2FormsElements, " get form[0]", "mnJavaScript_Access_form0");
		insertMenue(mnJavaScript_Access2FormsElements, " get form with name", "mnJavaScript_Access_formName");
		insertMenue(mnJavaScript_Access2FormsElements, " text value", "mnJavaScript_Access_textValue");
		insertMenue(mnJavaScript_Access2FormsElements, " checkbox", "mnJavaScript_Access_checkbox");
		insertMenue(mnJavaScript_Access2FormsElements, " multi checkbox", "mnJavaScript_Access_multicheckbox");
		insertMenue(mnJavaScript_Access2FormsElements, " radiobutton", "mnJavaScript_Access_radiobutton");
		insertMenue(mnJavaScript_Access2FormsElements, " combobox single-selection",
				"mnJavaScript_Access_comboboxSingle");
		insertMenue(mnJavaScript_Access2FormsElements, " combobox multiple-selection",
				"mnJavaScript_Access_comboboxMultiple");

		JMenu mainJavaScript_IfWhile = new JMenu("If/While/Switch");
		MainJavaScript.add(mainJavaScript_IfWhile);
		insertMenue(mainJavaScript_IfWhile, "if", "InsertJavaScript_If");
		insertMenue(mainJavaScript_IfWhile, "if else", "InsertJavaScript_If_Else");
		insertMenue(mainJavaScript_IfWhile, "do...while", "InsertJavaScript_Dowhile");
		insertMenue(mainJavaScript_IfWhile, "while", "InsertJavaScript_While");

		insertMenue(mainJavaScript_IfWhile, "for(i)", "InsertJavaScript_For_i");
		insertMenue(mainJavaScript_IfWhile, "foreach", "InsertJavaScript_Foreach");
		insertMenue(mainJavaScript_IfWhile, "foreachOf", "InsertJavaScript_ForeachOf");

		insertMenue(mainJavaScript_IfWhile, "switch", "InsertJavaScript_Switch");
		mainJavaScript_IfWhile.addSeparator();

		JMenu mainJavaScript_ParseisNaN = new JMenu("Parse / isNaN");
		MainJavaScript.add(mainJavaScript_ParseisNaN);

		insertMenue(mainJavaScript_ParseisNaN, "parseInt", "InsertJavaScript_ParseInt");
		insertMenue(mainJavaScript_ParseisNaN, "parseFloat", "InsertJavaScript_ParseFloat");
		insertMenue(mainJavaScript_ParseisNaN, "isNaN", "InsertJavaScript_isNaN");
		mainJavaScript_IfWhile.addSeparator();
		insertMenue(MainJavaScript, "Komma2Point", "InsertJavaScript_komma2Point");
		insertMenue(MainJavaScript, "toFixed (Nachkommazahlen)", "InsertJavaScript_toFixed");
		insertMenue(MainJavaScript, "Split (Trennen) result as an array)", "InsertJavaScript_split");
		insertMenue(MainJavaScript, "Insert Popupwindow", "InsertJavaScript_Popupwindow");

		JMenu mainJavaScript_Arrays = new JMenu("Arrays");
		MainJavaScript.add(mainJavaScript_Arrays);
		insertMenue(mainJavaScript_Arrays, "create an array", "mnJavaScript_Arrays_createArray");
		insertMenue(mainJavaScript_Arrays, "create a Multidim-Array", "mnJavaScript_Arrays_createMultidimArray");
		insertMenue(mainJavaScript_Arrays, "get length of an array", "mnJavaScript_lengthArray");
		insertMenue(mainJavaScript_Arrays, "add element to an array", "mnJavaScript_Arrays_pushArray");
		insertMenue(mainJavaScript_Arrays, "delete element from an array", "mnJavaScript_Arrays_sliceArra");

		JMenu mainJavaScript_Class = new JMenu("Class");
		MainJavaScript.add(mainJavaScript_Class);
		insertMenue(mainJavaScript_Class, "create Class", "mnJavaScript_Class_createClass");
		insertMenue(mainJavaScript_Class, "insert static attribut", "mnJavaScript_Class_StaticAttribut");

		insertMenue(MainJavaScript, "Regex", "InsertJavaScript_Regex");

		// PHP
		JMenu MainPHP = new JMenu("PHP");
		menuBar1.add(MainPHP);

		insertMenue(MainPHP, "PHP-Abschnitt", "InsertPHP_Range");
		insertMenue(MainPHP, "Insert PHP-Funktion", "InsertPHP_Funktion");
		
		insertMenue(MainPHP, "isset", "PHP_InsertPHP_isset");
		insertMenue(MainPHP, "Isset Select multiple", "mnPHP_InsertPHP_issetSelectMultiple");

		insertMenue(MainPHP, "is_numeric", "InsertPHP_Isnumeric");
		insertMenue(MainPHP, "is_int", "InsertPHP_IsInt");
		insertMenue(MainPHP, "is_float", "InsertPHP_IsFloat");
		insertMenue(MainPHP, "intval", "InsertPHP_IntVal");
		insertMenue(MainPHP, "floatval", "InsertPHP_FloatVal");

		JMenu mainPHP_Class = new JMenu("Class");
		MainPHP.add(mainPHP_Class);
		insertMenue(mainPHP_Class, "Insert class Result", "mnPHP_InsertClassResult");
		insertMenue(mainPHP_Class, "Insert class Number", "mnPHP_InsertClassNumber");
		insertMenue(mainPHP_Class, "PHP-Attribute (set/get)", "mnPHP_Attribute");

		insertMenue(MainPHP, "Include PHP-File", "mnPHP_InsertPHPFile");

		JMenu mainPHP_JSon = new JMenu("JSon");
		MainPHP.add(mainPHP_JSon);
		insertMenue(mainPHP_JSon, "JSon json_encode (pur)", "mnPHP_JSon_encodepur");
		insertMenue(mainPHP_JSon, "JSon-method in class (private attrib)", "mnPHP_JSon");
		insertMenue(mainPHP_JSon, "json_encode  (public attrib)", "mnPHP_json_encode");

		JMenu mainPHP_IfLopp = new JMenu("if/while/for/switch");
		MainPHP.add(mainPHP_IfLopp);
		insertMenue(mainPHP_IfLopp, "If", "mnPHP_If");
		insertMenue(mainPHP_IfLopp, "If else", "mnPHP_If_Else");
		insertMenue(mainPHP_IfLopp, "If ($ok) else", "mnPHP_If_ok_Else");
		insertMenue(mainPHP_IfLopp, "Do...while", "mnPHP_Dowhile");
		insertMenue(mainPHP_IfLopp, "While", "mnPHP_While");
		insertMenue(mainPHP_IfLopp, "For (i)", "mnPHP_For_i");
		insertMenue(mainPHP_IfLopp, "Foreach", "mnPHP_Foreach");
		insertMenue(mainPHP_IfLopp, "Switch", "mnPHP_Switch");
		
		
		
		JMenu mainPHP_Arrays = new JMenu("Arrays");
		MainPHP.add(mainPHP_Arrays);
		insertMenue(mainPHP_Arrays, "create Array", "mnPHP_Arrays_createArray");
		insertMenue(mainPHP_Arrays, "create Array with items", "mnPHP_Arrays_createArrayWithItems");
		insertMenue(mainPHP_Arrays, "create Multidim-Array", "mnPHP_Arrays_createMultidimArray");
		insertMenue(mainPHP_Arrays, "add element to Array", "mnPHP_Arrays_pushArray");
		insertMenue(mainPHP_Arrays, "Array length", "mnPHP_Arrays_arrayLength");
		insertMenue(mainPHP_Arrays, "foreach Array", "mnPHP_Arrays_foreach");

		insertMenue(MainPHP, "Regex", "mnPHP_regex");

		insertMenue(MainPHP, "echo text", "InsertPHP_echoText");
		insertMenue(MainPHP, "echo text und Variable", "InsertPHP_echoStringAndVariable");
		insertMenue(MainPHP, "echo text und Variable, Trennung", "InsertPHP_echoStringAndVariable_withPoint");

		insertMenue(MainPHP, "Weiterleitung", "mnPHP_weiterleitung");
		// Basis.setMenueFont( menuBar1, 14);

	} // setMenues

	public void setFontSize(int fontsize) {
		Basis.setMenueFont(menuBar1, false, fontsize);
		super._lineeditor.setFont(new Font("Courier New", Font.PLAIN, fontsize));
		super._editor.setFont(new Font("Courier New", Font.PLAIN, fontsize));
	}

}
