﻿import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

public class FInsertHTMLTable extends JDialog{
  public boolean bResult=false;
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Cancel");
  
  private JSpinner nud_countRows = new JSpinner( new SpinnerNumberModel(1,1, 2000, 1)   );
  private JSpinner nud_countCols = new JSpinner( new SpinnerNumberModel(1,1, 2000, 1)   );
  
  private JCheckBox chkHeaderInFirstRow = new JCheckBox("Header in the first row");
  private JCheckBox chkHeaderInFirstCol = new JCheckBox("Header in the first column");
  
  private JCheckBox chkthead = new JCheckBox("thead");
  private JCheckBox chktbody = new JCheckBox("tbody");
  private JCheckBox chktfoot = new JCheckBox("tfoot");

  private JCheckBox chkColgroup = new JCheckBox("with ColGroup");
  private JCheckBox chkCellSpacing = new JCheckBox("CellSpacing / Cellpadding");        
  private JComboBox cbCellFrame;      
  
  
        
 public int AnzRow=0;
 public int AnzCol=0;
 public boolean HeaderInFirstRow=false;
 public boolean HeaderInFirstCol=false;
 public boolean Head=false;
 public boolean Body=false;
 public boolean Foot=false;
 public boolean Colgroup=false;
 public boolean CellSpacing=false;
 public int CellFrame=0;
 
  
  public FInsertHTMLTable(Frame parent) {
    super(parent);	// oder super(parent, true);
    setModal(true);
    bResult=false;
    setSize(560, 500);
    setTitle("Erzeugen einer Tabelle");
    // setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
    setVisible(true);
  }

  private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );
    JLabel label1 = new JLabel("Insert a complete table");
    label1.setFont( new Font("Arial", Font.BOLD,20)  );
    label1.setForeground(Color.BLUE);
    this.getContentPane().add( label1,
       new GridBagConstraints(
           0, 0, 2, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(0,20,20,0), 0, 0));
     
    JLabel label2 = new JLabel("Number of the rows");
    label2.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( label2,
       new GridBagConstraints(
           0, 1, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,0), 0, 0));
    
    
    nud_countRows.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( nud_countRows,
       new GridBagConstraints(
           1, 1, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,10), 0, 0));
    
    JLabel label3 = new JLabel("Number of the columns");
    label3.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( label3,
       new GridBagConstraints(
           0, 2, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,30,0), 0, 0));
    
    nud_countCols.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( nud_countCols,
       new GridBagConstraints(
           1, 2, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,30,10), 0, 0));

    
    // --------------------
    chkHeaderInFirstRow.setFont( new Font("Arial", Font.BOLD,14)  );
    chkHeaderInFirstCol.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( chkHeaderInFirstRow,
       new GridBagConstraints(
           0, 3, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));
    
    this.getContentPane().add( chkHeaderInFirstCol,
       new GridBagConstraints(
           0, 4, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));
  

    chkthead.setFont( new Font("Arial", Font.BOLD,14)  );
    chktbody.setFont( new Font("Arial", Font.BOLD,14)  );
    chktfoot.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( chkthead,
       new GridBagConstraints(
           1, 3, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));
    this.getContentPane().add( chktbody,
       new GridBagConstraints(
           1, 4, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));
    this.getContentPane().add( chktfoot,
       new GridBagConstraints(
           1, 5, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,0), 0, 0));

   // ------------------
    chkColgroup.setFont( new Font("Arial", Font.BOLD,14)  );
    chkCellSpacing.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( chkColgroup,
       new GridBagConstraints(
           0, 6, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));
    this.getContentPane().add( chkCellSpacing,
       new GridBagConstraints(
           0, 7, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,0), 0, 0));
      
    JLabel label4 = new JLabel("Cell-Frame");
    label4.setFont( new Font("Arial", Font.BOLD,14)  );
    this.getContentPane().add( label4,
       new GridBagConstraints(
           0, 8, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,0), 0, 0));

    cbCellFrame = new JComboBox();
    cbCellFrame.setFont( new Font("Arial", Font.BOLD,14)  );
    cbCellFrame.addItem("No selected item");
    cbCellFrame.addItem("void: no margin (Default)");
    cbCellFrame.addItem("Above: margin top");
    cbCellFrame.addItem("Below: margin bottom");
    cbCellFrame.addItem("hsides: margin top and bottom");
    cbCellFrame.addItem("vsides: margin left and right");
    cbCellFrame.addItem("lhs: margin left");
    cbCellFrame.addItem("rhs: margin right");
    cbCellFrame.addItem("box: margin all sides");
    cbCellFrame.addItem("border: all sides");   
    cbCellFrame.setSelectedIndex(0);
   
    this.getContentPane().add( cbCellFrame,
       new GridBagConstraints(
           1, 8, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,10), 0, 0));
    
    // -----------------
    JPanel panel1 = new JPanel();
    panel1.setLayout( new FlowLayout() );
    panel1.add(bnOk);
    panel1.add(bnEsc);  
    bnOk.setFont( new Font("Arial", Font.BOLD,16)  );
    bnOk.setPreferredSize( bnEsc.getPreferredSize() );
    bnEsc.setFont( new Font("Arial", Font.BOLD,16)  );
    

    this.getContentPane().add(panel1,
       new GridBagConstraints(
           0,9, 2, 1, 100.0, 0.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.HORIZONTAL,
         new Insets(20,0,10,0), 0, 0));  // Top left Bottom Right
     
    bnOk.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnOK_click();
      }
    });
    bnEsc.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnEsc_click();
      }
    });     
  }
  
  private void  bnOK_click() {
     AnzRow = ((Integer)nud_countRows.getValue()).intValue();
     AnzCol = ((Integer)nud_countCols.getValue()).intValue();
     HeaderInFirstRow = chkHeaderInFirstRow.isSelected();

     HeaderInFirstCol = chkHeaderInFirstCol.isSelected();
     
     Head = chkthead.isSelected();
     Body = chktbody.isSelected();
     Foot = chktfoot.isSelected();

     Colgroup = chkColgroup.isSelected();
     CellSpacing = chkCellSpacing.isSelected();

    CellFrame = cbCellFrame.getSelectedIndex();
    
    bResult=true;
    setVisible(false);
    dispose();
  }

  private void  bnEsc_click() {
    bResult=false;
    setVisible(false);
    dispose();
  }
  
  
  
}
