import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class FInsertJavaFunction  extends JDialog{
  public boolean bResult=false;
  private String sFunctionname="";
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Abbruch");

  private JTextField TFunctionname = new JTextField();
  
  public String getFunctionname() {
    return sFunctionname;
  }
  
public FInsertJavaFunction(Frame parent) {
    super(parent);	// oder super(parent, true);
    setModal(true);
    bResult=false;
    setSize(450, 200);
    setTitle("Eintragen einer neuen Java-Script-Funktion");    
    setGUI();
    setVisible(true);
  }

 private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );
    JLabel label1 = new JLabel("Eintragen einer neuen Java-Script-Funktion");
    label1.setFont( new Font("Arial", Font.BOLD,16)  );
    label1.setForeground(Color.blue);
    
     this.getContentPane().add( label1,
       new GridBagConstraints(
           0, 0, 2, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(20,20,0,0), 0, 0));

     JLabel label2 = new JLabel("Funktionsname");
     label2.setFont( new Font("Arial", Font.PLAIN,12)  );
     this.getContentPane().add( label2,
       new GridBagConstraints(
           0, 1, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(20,20,20,0), 0, 0));

     TFunctionname.setFont( new Font("Arial", Font.PLAIN,12)  );
     this.getContentPane().add( TFunctionname,
       new GridBagConstraints(
           1, 1, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(20,20,20,20), 0, 0));
     
     
    JPanel panel1 = new JPanel(); 
    panel1.setLayout( new FlowLayout() );
    panel1.add(bnOk);
    panel1.add(bnEsc);  
    bnOk.setFont( new Font("Arial", Font.PLAIN,12)  );
    bnEsc.setFont( new Font("Arial", Font.PLAIN,12)  );
    bnOk.setPreferredSize(  bnEsc.getPreferredSize() );
    this.getContentPane().add(panel1,
       new GridBagConstraints(
           0,2, 2, 1, 100.0, 0.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.HORIZONTAL,
         new Insets(0,0,10,0), 0, 0));  // Top left Bottom Right
     
    bnOk.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnOK_click();
      }
    });
    bnEsc.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnEsc_click();
      }
    });
    
  }  // setGUI

  private void  bnOK_click() { 
    sFunctionname = TFunctionname.getText().trim();
    if (sFunctionname.equals("")) {
        Basis.ErrorBox("Bitte einen Funktionsname eingeben", "Hinweis");
        TFunctionname.requestFocus(); // setzt Focus
    }
    else {
      bResult=true;
      setVisible(false);
      dispose();
    }
  }

  private void  bnEsc_click() {
    bResult=false;
    setVisible(false);
    dispose();
  }
 
}
